

	TTL 'CLIP Against 5 Clipping Planes'

	INCLUDE 'COMN.ASM'

	SECTION PROGRAM

	XDEF GRID,GRLINE,XMIN

	XREF M_GRLINE

X1	EQU	PTBL+$0
Y1	EQU	PTBL+$2
Z1	EQU	PTBL+$4

X2	EQU	PTBL+$6
Y2	EQU	PTBL+$8
Z2	EQU	PTBL+$0A

T	EQU	PTBL+$0C

HGL	MACRO			* Horizontal Grid Line
	DC.W	\1*GRK,-GRSIZE*GRK,0
	DC.W	\1*GRK,GRSIZE*GRK,0
	ENDM

VGL	MACRO			* Vertical Grid Line
	DC.W	-GRSIZE*GRK,\1*GRK,0
	DC.W	 GRSIZE*GRK,\1*GRK,0
	ENDM

GRK	EQU	$800		* Grid Scale Constant
GRSIZE	EQU	$5		* Grid Size
GRLINE:	
	HGL	-$5
	HGL	-$4
	HGL	-$3	
	HGL	-$2
	HGL	-$1
	HGL	0
	HGL	$1
	HGL	$2
	HGL	$3
	HGL	$4
	HGL	$5

	VGL	-$5
	VGL	-$4
	VGL	-$3	
	VGL	-$2
	VGL	-$1
	VGL	0
	VGL	$1
	VGL	$2
	VGL	$3
	VGL	$4
	VGL	$5

GPTS	EQU	22*2		* Grid Points = Grid Lines * 2		

XMIN	DC.W	$100

* FLASH! For a grid of 22 lines:

*			All visible	Ground View	None Visible
*			(no clipping)
*			-------------	------------	-------------

* 	All 68010	   10.0 ms	    14.0 ms

* 	320 Level 1	    6.0 ms	     9.0 ms

*	320 Level 2	    5.4 ms	     6.2 ms	     3.5 ms

*	320 Level 3	    4.6 ms	     5.5 ms	     2.8 ms	     

*===================================================
	PAGE
* Level 3 320 Clipping Routines (mostly all in 320)
GRID:	
*=======
* Observer in A0, Point list in A1 (neither is modified), output in XP, YP, ZP
* Set Up 320 Presub for Grid
* Load Unit Vectors and do funny translation 
	MOVE.W 	#UV2,A0		
	MOVE.L	#m_wc1,A3
	MOVE.L	#9-1,D0
T2S1:	MOVE.W	(A0)+,(A3)+
	DBF	D0,T2S1

	MOVE.W	(A0)+,D0
	AND.W	#$07FF,D0	; Grid X Spacing is $800
	MOVE.W	D0,(A3)+	; Xt

	MOVE.W	(A0)+,D0
	AND.W	#$07FF,D0	; Grid Y Spacing is $800
	MOVE.W	D0,(A3)+	; Yt

	MOVE.W	(A0)+,(A3)+	; Zt
*=======
* m_wc1 in the 320 Ram is (m_wc1-M_320)/2	
	MOVE.W	#(m_wc1-M_320)/2,m_uv

* Input Point List
	MOVE.W	#M_GRLINE,m_tptr

* Number of Points
	MOVE.W	#GPTS,m_pcount		* Number of Grid Points
	MOVE.B	#GPTS,COUNT		

* Point to Output List
	MOVE.W	#(M_OUTL-M_320)/2,m_optr

* Set up Branch Instruction to Pre2
	MOVE.W	#$0F900,M_PROG
	MOVE.W	#M_PRE2,M_PROG+2

* Start 320
	TST.W	MBIOH	

* Wait for it to be done
T2S2	BTST	#1,IN1
	BNE	T2S2

* The points are ready, starting at M_OUTL
	MOVE.L	#M_OUTL,A1

G2LOOP:
* Clip, using 320 routines

	MOVE.W	(A1)+,m_x1
	MOVE.W	(A1)+,m_y1
	MOVE.W	(A1)+,m_z1
	MOVE.W	(A1)+,m_x2
	MOVE.W	(A1)+,m_y2
	MOVE.W	(A1)+,m_z2

	
* Set up Branch Instruction to Clip
	MOVE.W	#$0F900,M_PROG
	MOVE.W	#M_CLIP,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
T2S3	BTST	#1,IN1
	BNE	T2S3

* Is Line visible?
	TST.W	m_flag
	BNE	T2S4		* not visible, do not project it

* Line has been clipped and projected
	MOVE.W	m_x1,D1
	MOVE.W	m_y1,D2
	MOVE.W	m_x2,D4
	MOVE.W	m_y2,D5

* D1 = SX1
* D2 = SY1
*
* D4 = SX2
* D5 = SY2

* Format and add to VG Buffer
	MOVE.L	VG_PTR,A0
	MOVE.W	#$7200,(A0)+
	MOVE.W	#$6280,(A0)+

*   PLOT P1
	MOVE.W	D2,D6
	AND.W	#$1FFF,D6	*dy = PY1	
	MOVE.W	D6,(A0)+

	MOVE.W	D1,D6
	AND.W	#$1FFF,D6	*dx = PX1
	MOVE.W	D6,(A0)+

*   DRAWTO P2 
	SUB.W	D2,D5
	AND.W	#$1FFF,D5	* dy = PY2-PY1
	MOVE.W	D5,(A0)+

	SUB.W	D1,D4
	AND.W	#$1FFF,D4	
	OR.W	#$6000,D4	* dx = PX2-PX1
	MOVE.W	D4,(A0)+

	MOVE.W	#$8040,(A0)+
	MOVE.L	A0,VG_PTR

T2S4	SUBQ.B	#2,COUNT
	BNE	G2LOOP
	RTS
*===============================================================================
*===============================================================================
*===============================================================================
SW	SET	0
	IFEQ	SW

	PAGE

	XDEF NGRID,CPROJ,PSTAT,GRESUB,GLOOP
	XDEF RE1,RE2,LE1,LE2,TE1,TE2,BE1,BE2,XE1,XE2
	XDEF CLOOP,CL1,CL2,CL3,C_LINE

	XREF PRESUB,M_GRLINE

* GRID, naked 68010
NGRID:	
	MOVE.B	#GPTS/2,COUNT		* Lines = Points/2
	MOVE.L	#GRLINE,A1
GLOOP:
	MOVE.W 	#UV2,A0		
*	JSR	PRESUB
	BSR	GRESUB
	MOVE.W	XP,A2		* Save it in the Address Registers
	MOVE.W	YP,A3
	MOVE.W	ZP,A4

	ADDQ.L	#6,A1		* Get the second point
*	JSR	PRESUB
	BSR	GRESUB

	MOVE.W	XP,D3		* PX2
	MOVE.W	YP,D4		* PY2
	MOVE.W	ZP,D5		* PZ2

	MOVE.W	A2,D0		* PX1
	MOVE.W	A3,D1		* PY1
	MOVE.W	A4,D2		* PZ1

	ADDQ.L	#6,A1
	MOVE.L	A1,T_PTR

	BSR	C_LINE	  	*Clip the Line defined by Point 1 and Point 2 
*				 in D0-D5; and draw it.

	MOVE.L	T_PTR,A1
	SUBQ.B	#1,COUNT
	BNE	GLOOP
	RTS

	PAGE	
* Clip the Line defined by Point 1 and Point 2 in D0-D5
C_LINE	MOVEM.W	D0-D5,PTBL	* Save the points

	BSR	PSTAT		* Form the Point Status Bytes
	MOVE.B	#6,T_COUNT	* Failsafe loop counter

* If STAT1 and STAT2 are both zero, the line is totally visible
CLOOP:	MOVE.B	STAT1,D7
	OR.B	STAT2,D7
	BNE	CL1
* Project and display the line
	BRA	CPROJ
* If STAT1 and STAT2 have common bits set, it is totally invisible
CL1	MOVE.B	STAT1,D7
	AND.B	STAT2,D7
	BEQ	CL2
EXIT	RTS

CL2	MOVE.B	T_COUNT,D7
	SUBQ.B	#1,D7
	CMP.B	MODEL,D7
	BGE	CL2A
	MOVE.B	D7,MODEL

CL2A	SUBQ.B	#1,T_COUNT
	BEQ	CL4

	BTST	#0,STAT2
	BNE	XE2	   *(Clip Point 2 to XMIN and return to CLOOP)
	BTST	#0,STAT1
	BNE	XE1	   *(Clip Point 1 to XMIN and return to CLOOP)

	BTST	#1,STAT2
	BNE	RE2	   *(Clip Point 2 to Right Edge and return to CLOOP)
	BTST	#2,STAT2
	BNE	LE2	   *(Clip Point 2 to Left Edge and return to CLOOP)

	BTST	#3,STAT2
	BNE	TE2	   *(Clip Point 2 to Top Edge and return to CLOOP)
	BTST	#4,STAT2
	BNE	BE2	   *(Clip Point 2 to Bottom Edge and return to CLOOP)

CL3	BTST	#1,STAT1
	BNE	RE1	   *(Clip Point 1 to Right Edge and return to CLOOP)
	BTST	#2,STAT1
	BNE	LE1	   *(Clip Point 1 to Left Edge and return to CLOOP)

	BTST	#3,STAT1
	BNE	TE1	   *(Clip Point 1 to Top Edge and return to CLOOP)
	BTST	#4,STAT1
	BNE	BE1	   *(Clip Point 1 to Bottom Edge and return to CLOOP)

CL4	RTS
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 1 to XMIN,   Xv = XMIN 
*
*  	T =    	XMIN-X1
*		-------
*		(X2-X1)
*
XE1:	MOVE.W	X2,D0
	SUB.W	X1,D0
	BEQ	EXIT

	MOVE.W	XMIN,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = XMIN
	MOVE.W	XMIN,D0		* D0 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D1
	SUB.W	Y1,D1
	MULS	D6,D1
	ASL.L	#2,D1
	SWAP	D1
	ADD.W	Y1,D1		* D1 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D2
	SUB.W	Z1,D2
	MULS	D6,D2
	ASL.L	#2,D2
	SWAP	D2
	ADD.W	Z1,D2		* D2 = Zv

	MOVEM.W	D0-D2,PTBL	* Save new Point 1

	BSR	PSTAT1		* New Status Byte for Point 1

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to XMIN,   Xv = XMIN 
*
*  	T =    	XMIN-X1
*		-------
*		(X2-X1)
*
XE2:	MOVE.W	X2,D3
	SUB.W	X1,D3
	BEQ	EXIT

	MOVE.W	XMIN,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = XMIN
	MOVE.W	XMIN,D3		* D3 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D4
	SUB.W	Y1,D4
	MULS	D6,D4
	ASL.L	#2,D4
	SWAP	D4
	ADD.W	Y1,D4		* D4 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D5
	SUB.W	Z1,D5
	MULS	D6,D5
	ASL.L	#2,D5
	SWAP	D5
	ADD.W	Z1,D5		* D5 = Zv

	MOVEM.W	D3-D5,PTBL+6	* Save new Point 2

	BSR	PSTAT2		* New Status Byte for Point 2

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 1 to the Right Edge, Y=X
*
*	T =    (Y1-X1)
*	    ---------------
*	    (X2-X1)-(Y2-Y1)
*
RE1:	MOVE.W	X2,D0
	SUB.W	X1,D0
	SUB.W	Y2,D0
	ADD.W	Y1,D0
	BEQ	EXIT

	MOVE.W	Y1,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D0
	SUB.W	X1,D0
	MULS	D6,D0
	ASL.L	#2,D0
	SWAP	D0		
	ADD.W	X1,D0		* D0 = Xv

* Yv = Xv
	MOVE.W	D0,D1		* D1 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D2
	SUB.W	Z1,D2
	MULS	D6,D2
	ASL.L	#2,D2
	SWAP	D2
	ADD.W	Z1,D2		* D2 = Zv

	MOVEM.W	D0-D2,PTBL	* Save new Point 1

	BSR	PSTAT1		* New Status Byte for Point 1 

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to the Right Edge, Y=X
*
*	T =    (Y1-X1)
*	    ---------------
*	    (X2-X1)-(Y2-Y1)
*
RE2:	MOVE.W	X2,D3
	SUB.W	X1,D3
	SUB.W	Y2,D3
	ADD.W	Y1,D3
	BEQ	EXIT

	MOVE.W	Y1,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D3
	SUB.W	X1,D3
	MULS	D6,D3
	ASL.L	#2,D3
	SWAP	D3		
	ADD.W	X1,D3		* D3 = Xv

* Yv = Xv
	MOVE.W	D3,D4		* D4 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D5
	SUB.W	Z1,D5
	MULS	D6,D5
	ASL.L	#2,D5
	SWAP	D5
	ADD.W	Z1,D5		* D5 = Zv

	MOVEM.W	D3-D5,PTBL+6	* Save new Point 2

	BSR	PSTAT2		* New Status Byte for Point 2 

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 1 to the Left Edge, Y=-X
*
* 	T =    -(X1+Y1)
*	    ---------------
*	    (X2-X1)+(Y2-Y1)
*
LE1:	MOVE.W	X2,D0
	SUB.W	X1,D0
	ADD.W	Y2,D0
	SUB.W	Y1,D0
	BEQ	EXIT

	MOVE.W	Y1,D6
	NEG.W	D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D0
	SUB.W	X1,D0
	MULS	D6,D0
	ASL.L	#2,D0
	SWAP	D0		
	ADD.W	X1,D0		* D0 = Xv

* Yv = -Xv
	MOVE.W	D0,D1		
	NEG.W	D1		* D1 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D2
	SUB.W	Z1,D2
	MULS	D6,D2
	ASL.L	#2,D2
	SWAP	D2
	ADD.W	Z1,D2		* D2 = Zv

	MOVEM.W	D0-D2,PTBL	* Save new Point 1

	BSR	PSTAT1		* New Status Byte for Point 1 

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to the Left Edge, Y=-X
*
* 	T =    -(X1+Y1)
*	    ---------------
*	    (X2-X1)+(Y2-Y1)
*
LE2:	MOVE.W	X2,D3
	SUB.W	X1,D3
	ADD.W	Y2,D3
	SUB.W	Y1,D3
	BEQ	EXIT

	MOVE.W	Y1,D6
	NEG.W	D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D3
	SUB.W	X1,D3
	MULS	D6,D3
	ASL.L	#2,D3
	SWAP	D3		
	ADD.W	X1,D3		* D3 = Xv

* Yv = -Xv
	MOVE.W	D3,D4		
	NEG.W	D4		* D4 = Yv

* Zv = (Z2-Z1)*T + Z1
	MOVE.W	Z2,D5
	SUB.W	Z1,D5
	MULS	D6,D5
	ASL.L	#2,D5
	SWAP	D5
	ADD.W	Z1,D5		* D5 = Zv

	MOVEM.W	D3-D5,PTBL+6	* Save new Point 2

	BSR	PSTAT2		* New Status Byte for Point 2 

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 1 to the Top Edge, Z=X
*
*	T =    (Z1-X1)
*	    ---------------
*	    (X2-X1)-(Z2-Z1)
*
TE1:	MOVE.W	X2,D0
	SUB.W	X1,D0
	SUB.W	Z2,D0
	ADD.W	Z1,D0
	BEQ	EXIT

	MOVE.W	Z1,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D0
	SUB.W	X1,D0
	MULS	D6,D0
	ASL.L	#2,D0
	SWAP	D0		
	ADD.W	X1,D0		* D0 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D1
	SUB.W	Y1,D1
	MULS	D6,D1
	ASL.L	#2,D1
	SWAP	D1
	ADD.W	Y1,D1		* D1 = Yv

* Zv = Xv
	MOVE.W	D0,D2		* D2 = Zv

	MOVEM.W	D0-D2,PTBL	* Save new Point 1

	BSR	PSTAT1		* New Status Byte for Point 1 

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to the Top Edge, Z=X
*
*	T =    (Z1-X1)
*	    ---------------
*	    (X2-X1)-(Z2-Z1)
*
TE2:	MOVE.W	X2,D3
	SUB.W	X1,D3
	SUB.W	Z2,D3
	ADD.W	Z1,D3
	BEQ	EXIT

	MOVE.W	Z1,D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D3
	SUB.W	X1,D3
	MULS	D6,D3
	ASL.L	#2,D3
	SWAP	D3		
	ADD.W	X1,D3		* D3 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D4
	SUB.W	Y1,D4
	MULS	D6,D4
	ASL.L	#2,D4
	SWAP	D4
	ADD.W	Y1,D4		* D4 = Yv

* Zv = Xv
	MOVE.W	D3,D5		* D5 = Zv

	MOVEM.W	D3-D5,PTBL+6	* Save new Point 2

	BSR	PSTAT2		* New Status Byte for Point 2 

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 1 to the Bottom Edge, Z=-X
*
*	T =    -(X1+Z1)
*	    ---------------
*	    (X2-X1)+(Z2-Z1)
*
BE1:	MOVE.W	X2,D0
	SUB.W	X1,D0
	ADD.W	Z2,D0
	SUB.W	Z1,D0
	BEQ	EXIT

	MOVE.W	Z1,D6
	NEG.W	D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D0,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D0
	SUB.W	X1,D0
	MULS	D6,D0
	ASL.L	#2,D0
	SWAP	D0		
	ADD.W	X1,D0		* D0 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D1
	SUB.W	Y1,D1
	MULS	D6,D1
	ASL.L	#2,D1
	SWAP	D1
	ADD.W	Y1,D1		* D1 = Yv

* Zv = -Xv
	MOVE.W	D0,D2		
	NEG.W	D2		* D2 = Zv

	MOVEM.W	D0-D2,PTBL	* Save new Point 1

	BSR	PSTAT1		* New Status Byte for Point 1 

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Clip Point 2 to the Bottom Edge, Z=-X
*
*	T =    -(X1+Z1)
*	    ---------------
*	    (X2-X1)+(Z2-Z1)
*
BE2:	MOVE.W	X2,D3
	SUB.W	X1,D3
	ADD.W	Z2,D3
	SUB.W	Z1,D3
	BEQ	EXIT

	MOVE.W	Z1,D6
	NEG.W	D6
	SUB.W	X1,D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6

	DIVS	D3,D6		* D6 = T = 0 to 1.00  (1.00 = 4000)

* Xv = (X2-X1)*T + X1
	MOVE.W	X2,D3
	SUB.W	X1,D3
	MULS	D6,D3
	ASL.L	#2,D3
	SWAP	D3		
	ADD.W	X1,D3		* D3 = Xv

* Yv = (Y2-Y1)*T + Y1
	MOVE.W	Y2,D4
	SUB.W	Y1,D4
	MULS	D6,D4
	ASL.L	#2,D4
	SWAP	D4
	ADD.W	Y1,D4		* D4 = Yv

* Zv = -Xv
	MOVE.W	D3,D5		
	NEG.W	D5		* D5 = Zv

	MOVEM.W	D3-D5,PTBL+6	* Save new Point 2

	BSR	PSTAT2		* New Status Byte for Point 2 

	BRA	CLOOP
*-------------------------------------------------------------------------------
	PAGE
* Project the two points and draw a line between them
CPROJ:
*Screen Y1
	SWAP	D2		* PZ1
	CLR.W	D2
	ASR.L	#2,D2
	DIVS	D0,D2		* D2 = PZ1/PX1	
	ASR.W	#5,D2		* D2 = PZ1/PX1 (scaled)	<<<<<<<<<<<<<<<<<<<<<

*Screen X1
	SWAP	D1		* PY1
	CLR.W	D1
	ASR.L	#2,D1
	DIVS	D0,D1		* D1 = PY1/PX1
	ASR.W	#5,D1		* D1 = PY1/PX1 (scaled) <<<<<<<<<<<<<<<<<<<<<

*Screen Y2
	SWAP	D5		* PZ2
	CLR.W	D5
	ASR.L	#2,D5
	DIVS	D3,D5		* D5 = PZ2/PX2	
	ASR.W	#5,D5		* D5 = PZ2/PX2 (scaled)	<<<<<<<<<<<<<<<<<<<<<

*Screen X2
	SWAP	D4		* PY2
	CLR.W	D4
	ASR.L	#2,D4
	DIVS	D3,D4		* D4 = PY2/PX2
	ASR.W	#5,D4		* D4 = PY2/PX2 (scaled) <<<<<<<<<<<<<<<<<<<<<
		
* D2 = SY1
* D1 = SX1
*
* D5 = SY2
* D4 = SX2

* Format and add to VG Buffer
	MOVE.L	VG_PTR,A0
	MOVE.W	#$7200,(A0)+
	MOVE.W	#$6280,(A0)+

*   PLOT P1
	MOVE.W	D2,D6
	AND.W	#$1FFF,D6	*dy = PY1	
	MOVE.W	D6,(A0)+

	MOVE.W	D1,D6
	AND.W	#$1FFF,D6	*dx = PX1
	MOVE.W	D6,(A0)+

*   DRAWTO P2 
	SUB.W	D2,D5
	AND.W	#$1FFF,D5	* dy = PY2-PY1
	MOVE.W	D5,(A0)+

	SUB.W	D1,D4
	AND.W	#$1FFF,D4	
	OR.W	#$6000,D4	* dx = PX2-PX1
	MOVE.W	D4,(A0)+

	MOVE.W	#$8040,(A0)+
	MOVE.L	A0,VG_PTR

	RTS
*-------------------------------------------------------------------------------
	PAGE
PSTAT:
* Form Point 1 status word
	CLR.L	D7

* Is PX1 < XMIN ?  (Behind or too close)	$01
	CMP.W	XMIN,D0
	BGE	PS1
	BSET	#0,D7

* Is PY1 > PX1 ? (Beyond right)   		$02
PS1	CMP.W	D0,D1
	BLE	PS2
	BSET	#1,D7

* Is PY1 < -PX1 ?  (Beyond Left)  		$04
PS2	MOVE.W	D0,D6		
	NOT.W	D6
	CMP.W	D6,D1
	BGE	PS3
	BSET	#2,D7

* Is PZ1 > PX1 ? (Above top)	  		$08
PS3	CMP.W	D0,D2
	BLE	PS4
	BSET	#3,D7

* Is PZ1 < -PX1 ? (Below bottom)  		$10	
PS4	CMP.W	D6,D2
	BGE	PS5
	BSET	#4,D7

PS5	MOVE.B	D7,STAT1			* Point 1 status word

*----------------------------
* Form Point 2 status word
	CLR.L	D7		* STAT2

* Is PX2 < XMIN ?  (Behind or too close)  	$01
	CMP.W	XMIN,D3
	BGE	PS10
	BSET	#0,D7	

* Is PY2 > PX2 ? (Beyond right)   		$02
PS10	CMP.W	D3,D4		
	BLE	PS11
	BSET	#1,D7		 

* Is PY2 < -PX2 ?  (Beyond Left)  		$04
PS11	MOVE.W	D3,D6		
	NOT.W	D6
	CMP.W	D6,D4		
	BGE	PS12
	BSET	#2,D7	

* Is PZ2 > PX2 ? (Above top)	  		$08
PS12	CMP.W	D3,D5
	BLE	PS13
	BSET	#3,D7		

* Is PZ2 < -PX2 ? (Below bottom)  		$10	
PS13	CMP.W	D6,D5
	BGE	PS14
	BSET	#4,D7		

PS14	MOVE.B	D7,STAT2			* Point 2 status word

	RTS
*-------------------------------------------------------------------------------
	PAGE
PSTAT1:
* Form Point 1 status word
	CLR.L	D7

* Is PX1 < XMIN ?  (Behind or too close)	$01
	CMP.W	XMIN,D0
	BGE	PST1
	BSET	#0,D7

* Is PY1 > PX1 ? (Beyond right)   		$02
PST1	CMP.W	D0,D1
	BLE	PST2
	BSET	#1,D7

* Is PY1 < -PX1 ?  (Beyond Left)  		$04
PST2	MOVE.W	D0,D6		
	NOT.W	D6
	CMP.W	D6,D1
	BGE	PST3
	BSET	#2,D7

* Is PZ1 > PX1 ? (Above top)	  		$08
PST3	CMP.W	D0,D2
	BLE	PST4
	BSET	#3,D7

* Is PZ1 < -PX1 ? (Below bottom)  		$10	
PST4	CMP.W	D6,D2
	BGE	PST5
	BSET	#4,D7

PST5	MOVE.B	D7,STAT1			* Point 1 status word
	RTS
*----------------------------
PSTAT2:
* Form Point 2 status word
	CLR.L	D7		* STAT2

* Is PX2 < XMIN ?  (Behind or too close)  	$01
	CMP.W	XMIN,D3
	BGE	PST10
	BSET	#0,D7	

* Is PY2 > PX2 ? (Beyond right)   		$02
PST10	CMP.W	D3,D4		
	BLE	PST11
	BSET	#1,D7		 

* Is PY2 < -PX2 ?  (Beyond Left)  		$04
PST11	MOVE.W	D3,D6		
	NOT.W	D6
	CMP.W	D6,D4		
	BGE	PST12
	BSET	#2,D7	

* Is PZ2 > PX2 ? (Above top)	  		$08
PST12	CMP.W	D3,D5
	BLE	PST13
	BSET	#3,D7		

* Is PZ2 < -PX2 ? (Below bottom)  		$10	
PST13	CMP.W	D6,D5
	BGE	PST14
	BSET	#4,D7		

PST14	MOVE.B	D7,STAT2			* Point 2 status word

	RTS
*-------------------------------------------------------------------------------
	PAGE
* GRID PRESUBTRACT
*
*	XP = AX * (X-XT) + BX * (Y-YT) + CX * (Z-ZT)
*	YP = AY * (X-XT) + BY * (Y-YT) + CY * (Z-ZT)
*	ZP = AZ * (X-XT) + BZ * (Y-YT) + CZ * (Z-ZT)
*
* Calling Routine supplies:
*	A0 points to Unit Vectors
*	A1 points to Object Position List
*	
* Uses:
*	D0 = X-XT
*	D1 = Y-YT
*	D2 = Z-ZT
*
*	D6 = Dn * D6, also temp
*	D7 is the Accumulator
*
GRESUB:	
	MOVE.W	XT(A0),D0
	AND.W	#$07FF,D0	* Grid X spacing is $800
	NEG.W	D0
	ADD.W	X(A1),D0	

	MOVE.W	YT(A0),D1
	AND.W	#$07FF,D1	* Grid Y spacing is $800  
	NEG.W	D1
	ADD.W	Y(A1),D1

	MOVE.W	Z(A1),D2
	SUB.W	ZT(A0),D2	*D2 = Z-ZT

	CLR.L	D7		*clear accumulator
	MOVE.W	AX(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AX*(X-XT)

	MOVE.W	BX(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AX*(X-XT) + BX*(Y-YT)

	MOVE.W	CX(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AX*(X-XT) + BX*(Y-YT) + CX*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,XP		*XP = AX*(X-XT) + BX*(Y-YT) + CX*(Z-ZT) <<<<<<<
*------------------------------------------------------------------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AY(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AY*(X-XT)

	MOVE.W	BY(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AY*(X-XT) + BY*(Y-YT)

	MOVE.W	CY(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AY*(X-XT) + BY*(Y-YT) + CY*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,YP		*YP = AY*(X-XT) + BY*(Y-YT) + CY*(Z-ZT) <<<<<<<
*------------------------------------------------------------------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AZ(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AZ*(X-XT)

	MOVE.W	BZ(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AZ*(X-XT) + BZ*(Y-YT)

	MOVE.W	CZ(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AZ*(X-XT) + BZ*(Y-YT) + CZ*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,ZP		*ZP = AZ*(X-XT) + BZ*(Y-YT) + CZ*(Z-ZT) <<<<<<<

	RTS
*===============================================================================
*===============================================================================
	ENDC


SW	SET	0
	IFEQ	SW

	PAGE
* 320 Clipping Routines, Level 2. 
* Grid Presubtract and Clipping, one point at at time

	XDEF	L2GRID,GROOP,C_320

L2GRID:	
	MOVE.B	#22,COUNT		* There are 22. lines
*=======
* Observer in A0, Point list in A1 (neither is modified), output in XP, YP, ZP
* Set Up 320 Presub for Grid
* Load Unit Vectors and do funny translation 
	MOVE.W 	#UV2,A0		
	MOVE.L	#m_wc1,A3
	MOVE.L	#9-1,D0
TS1:	MOVE.W	(A0)+,(A3)+
	DBF	D0,TS1

	MOVE.W	(A0)+,D0
	AND.W	#$07FF,D0	; Grid X Spacing is $800
	MOVE.W	D0,(A3)+	; Xt

	MOVE.W	(A0)+,D0
	AND.W	#$07FF,D0	; Grid Y Spacing is $800
	MOVE.W	D0,(A3)+	; Yt

	MOVE.W	(A0)+,(A3)+	; Zt
*=======
* Load 320 pointers	
	MOVE.W	#(m_wc1-M_320)/2,m_uv

	MOVE.W	#M_GRLINE,m_tptr

* Set up Branch Instruction to Presub
	MOVE.W	#$0F900,M_PROG
	MOVE.W	#M_PRESUB,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
TGLP1	BTST	#1,IN1
	BNE	TGLP1

* The first point is done
	MOVE.W	m_xp,D0
	MOVE.W	m_yp,D1
	MOVE.W	m_zp,D2

* Do the next point
	MOVE.W	#M_PRECON,M_PROG+2

	BRA	TGLP3A

* Next Line
GROOP:	

* Start 320
	TST.W	MBIOH

* Wait for it to be done
TGLP3	BTST	#1,IN1
	BNE	TGLP3

* Point 1 is done
	MOVE.W	m_xp,D0
	MOVE.W	m_yp,D1
	MOVE.W	m_zp,D2

* Start 320
TGLP3A	TST.W	MBIOH

* Wait for it to be done
TGLP4	BTST	#1,IN1
	BNE	TGLP4

* Point 2 is done
	MOVE.W	m_xp,D3
	MOVE.W	m_yp,D4
	MOVE.W	m_zp,D5

	BSR	C_320			* Clip the line in D0-D5

	MOVE.W	#M_PRECON,M_PROG+2	* Restore PRECON program

	SUBQ.B	#1,COUNT
	BNE	GROOP
	RTS

	PAGE
* Clip only, using 320 routines. We will keep it in for now.
C_320:	
	MOVE.W	D0,m_x1
	MOVE.W	D1,m_y1
	MOVE.W	D2,m_z1
	MOVE.W	D3,m_x2
	MOVE.W	D4,m_y2
	MOVE.W	D5,m_z2
	
* Set up Branch Instruction to Clip
	MOVE.W	#$0F900,M_PROG
	MOVE.W	#M_CLIP,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
TCLP1	BTST	#1,IN1
	BNE	TCLP1

* Is Line visible?
	TST.W	m_flag
	BEQ	TCLP2
	RTS			* not visible, do not project it

* Line has been clipped and projected
TCLP2	
	MOVE.W	m_x1,D1
	MOVE.W	m_y1,D2
	MOVE.W	m_x2,D4
	MOVE.W	m_y2,D5

* D1 = SX1
* D2 = SY1
*
* D4 = SX2
* D5 = SY2

* Format and add to VG Buffer
	MOVE.L	VG_PTR,A0
	MOVE.W	#$7200,(A0)+
	MOVE.W	#$6280,(A0)+

*   PLOT P1
	MOVE.W	D2,D6
	AND.W	#$1FFF,D6	*dy = PY1	
	MOVE.W	D6,(A0)+

	MOVE.W	D1,D6
	AND.W	#$1FFF,D6	*dx = PX1
	MOVE.W	D6,(A0)+

*   DRAWTO P2 
	SUB.W	D2,D5
	AND.W	#$1FFF,D5	* dy = PY2-PY1
	MOVE.W	D5,(A0)+

	SUB.W	D1,D4
	AND.W	#$1FFF,D4	
	OR.W	#$6000,D4	* dx = PX2-PX1
	MOVE.W	D4,(A0)+

	MOVE.W	#$8040,(A0)+
	MOVE.L	A0,VG_PTR

	RTS

*===============================================================================
*===============================================================================
	ENDC


	END
