	TTL 'HEADUP DISPLAY'


	INCLUDE 'COMN.ASM'


	XREF VJ_TITL,VJ_SITE,VJ_ZOOM,VJ_THRUST,VJ_BKBOX,VJ_HDN
	XREF VJ_FUEL2
	XREF VGMSGA

	XDEF VGOVER,HUD,VWTHRUST,HEADING,ALTITUDE,AIRSPEED,VWFUEL
	XDEF HD10,HD20,HD30,HD40
	XDEF ATNTBL,ATN10,ATN20,ATN30,ATN40,ATN50,ATN60,ATN70,ATN80
	XDEF XGTY,YGTX,ATAN
	XDEF VW_1D,VW_2D,VW_3D,VW_4D
	XDEF BINBCD,BCDBIN
	XDEF DIS_HDN
	XDEF HDN50,HDN60,HDN70,HDN75,HDN100,HDN110,HDN150

	SECTION PROGRAM

* VG Overlay
VGOVER	MOVE.L	VG_PTR,A0
	MOVE.W	#$8040,(A0)+

	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box 

	MOVE.W 	#VJ_TITL,(A0)+		*Head up display titles

	MOVE.W 	#$7400,(A0)+		*SCALE: Bin=4,Lin=0
	MOVE.W	#$6740,(A0)+		*COLOR White, Z=40
	MOVE.W	#VJ_ZOOM,(A0)+		*Zoom window

	MOVE.W	#VJ_SITE,(A0)+		*Target Site
	
	MOVE.L	A0,VG_PTR
	RTS
	

* Head Up Display
HUD
	BSR	AIRSPEED
	BSR	ALTITUDE
	BSR	HEADING
	BSR	VWTHRUST	* View Thrust
	BSR	VWFUEL		* View Fuel
	RTS

	PAGE
* Calculate and Display Airspeed

* Calculate Airspeed = ABS (Dot Product of Velocity and X unit Vector)
*		     = ABS (VX*AX + VY*BX + VZ*CX)
AIRSPEED:
	MOVEA.W	#UV2,A1		*Airspeed will be for UV2
*	MOVE.W	THRUST(A1),D1
*	BRA	ASP2

*	MOVE.W	AX(A1),D1
*	MULS	VX(A1),D1	*D1 = VX*AX

*	MOVE.W	BX(A1),D0
*	MULS	VY(A1),D0
*	ADD.L	D0,D1		* D1 = VX*AX + VY*BX

*	MOVE.W	CX(A1),D0
*	MULS	VY(A1),D0
*	ADD.L	D0,D1		* D1 = VX*AX + VY*BX + VZ*CX

*	ASL.L	#2,D1
*	SWAP	D1		* Adjust Binary point

*	TST.W	D1
*	BPL	ASP2
*	NEG.W	D1		* make airspeed positive

ASP2	MOVE.W	ASPD,D0		* D0 = old airspeed 

*ASPD = Old Airspeed + (New Airspeed - Old Airspeed)/16
*	SUB.W	D0,D1
*	ASR.W	#4,D1
*	ADD.W	D1,D0
*	MOVE.W	D0,ASPD

*Display Airspeed
*Convert Positive Binary to BCD
*Input binary in D0
*Number of Shifts in D1.L
*Output BCD in D0
	MOVE.L	#15,D1		* $4000 will come out as 8192.
	BSR	BINBCD		* Input in D0, Output in D0 (4 BCD digits)

	MOVE.L	D0,D6		* make a copy
*				  D6 Low Byte contains LS Digit + Fraction

	BSR	BCDBIN		* convert Low byte to Binary (result in D0)
	MOVE.W	D0,D1		* make a copy of binary LS digit + fraction

*Vector to beginning of airspeed readout
	MOVE.L	VG_PTR,A0
	MOVE.W	#$7200,(A0)+	* SCALE

	NEG.W	D0
	AND.W	#$1FFF,D0	
	MOVE.W	D0,(A0)+	*dy

	MOVE.W	#$9C,(A0)+	*dx

	MOVE.W	#$7300,(A0)+	*scale

	MOVE.L	D6,D0
	
	LSR.L	#8,D0		* 
	BSR	VW_2D		* View 2 BCD most significant airspeed digits
	
	CLR.L	D0
	BSR	VW_1D		*last digit will be zero

	MOVE.W	#$0CC,(A0)+	*dy
	MOVE.W	#$1FB8,(A0)+	*dx (-$48)


*Increment tens			* D6 = 1000 100 10 1
	LSR.L	#8,D6		* D6 = 100 10
	MOVE.W	D6,D0		* D0 = 100 10 

	MOVE.B	#$1,D1
	AND.W	#$0FFEF,SR	* Clear X Flag
	ABCD.B	D1,D0		* 

	BSR	VW_2D		*draw two most signicant digits
	CLR.W	D0
	BSR	VW_1D		*the last one is zero

	MOVE.W	#$8040,(A0)+	*Center

	MOVE.L	A0,VG_PTR
	
	RTS
	PAGE
*Display Altitude

ALTITUDE:
	MOVE.W	(ZT+UV2),D0		* Binary altitude
	SUB.W	#$20,D0			* Correct for eye level

*Convert Positive Binary to BCD
*Input binary in D0
*Number of Shifts in D1.L
*Output BCD in D0
	MOVE.L	#17,D1
	BSR	BINBCD		* Input in D0, Output in D0 (5 BCD digits)

	MOVE.L	D0,D6		* make a copy
*				  D6 Low Byte contains LS Digit + Fraction

	BSR	BCDBIN		* convert Low byte to Binary (result in D0)
	MOVE.W	D0,D1		* make a copy of binary LS digit + fraction

*Vector to beginning of altitude readout
	MOVE.L	VG_PTR,A0
	MOVE.W	#$7200,(A0)+	* SCALE

	NEG.W	D0
	AND.W	#$1FFF,D0	
	MOVE.W	D0,(A0)+	*dy

	MOVE.W	#$1F2C,(A0)+	*dx

	MOVE.W	#$7300,(A0)+	*scale

	MOVE.L	D6,D0
	
	LSR.L	#8,D0		* 
	BSR	VW_3D		* View 3 BCD most significant altitude digits
	
	CLR.L	D0
	BSR	VW_2D		*last two digits will be zero

	MOVE.W	#$0CC,(A0)+	*dy
	MOVE.W	#$1F86,(A0)+	*dx

*Increment hundreds		* D6 = 10,000 1000 100 10 1
	LSR.L	#8,D6		* D6 = 10,000 1000 100 
	MOVE.W	D6,D0		* D0 = 10,000 1000 100 

	LSR.L	#8,D0		* D0 = 10,000 (most significant digit) 
	MOVE.B	#$1,D1
	AND.W	#$0FFEF,SR	* Clear X Flag
	ABCD.B	D1,D6		* use D6 for least significant digits
	CLR.W	D1
	ABCD.B	D1,D0

	BSR	VW_1D		*draw most significant digit first
	MOVE.W	D6,D0
	BSR	VW_2D		*then the next two
	CLR.W	D0
	BSR	VW_2D		*the last two are zero

	MOVE.W	#$8040,(A0)+	*Center

	MOVE.L	A0,VG_PTR
	
	RTS

* View Fuel for Ship 1
VWFUEL
	MOVE.L	VG_PTR,A0

	MOVE.W	#$7300,(A0)+			* Scale 3
	MOVE.W	#((-416)&$1FFF),(A0)+		* dy
	MOVE.W	#((-224)&$1FFF),(A0)+		* dx

	MOVE.W	#$6380,(A0)+			* Color TURQ
	MOVE.W	#VJ_FUEL2,(A0)+			* 'FUEL'

	MOVE.W	#0,(A0)+			* dy
	MOVE.W	#80,(A0)+			* dx

	MOVE.W	#$6680,(A0)+				* COLOR YELLOW

*Display Fuel
*Convert Positive Binary to BCD
*Input binary in D0
*Number of Shifts in D1.L
*Output BCD in D0
	MOVE.L	FUEL,D0		* About 4 6500 for 3 minutes
	LSR.L	#4,D0
	MOVE.L	#10,D1		* 
	BSR	BINBCD		* Input in D0, Output in D0 (4 BCD digits)

	JSR	VW_3D				* Display 3 Digits

	MOVE.W	#$7200,(A0)+			* Scale

	MOVE.W	#$8040,(A0)+

	MOVE.L	A0,VG_PTR

	RTS

* View Thrust for Ship 1
VWTHRUST
	MOVE.L	VG_PTR,A0

	MOVE.W	#VJ_THRUST,(A0)+
	MOVE.W	#$2,(A0)+		dy=2
	MOVE.W	#$20,(A0)+		dx=$20

	CLR.W	D0
	MOVE.W	THRUST+UV2,D0
	LSR.W	#6,D0			*scale the thrust
	MOVE.L	D0,D1			*make a copy

	MOVE.W	#$0,(A0)+		*Vector over; dy=0
	AND.W	#$1FFF,D1
	OR.W	#$6000,D1
	MOVE.W	D1,(A0)+		*dx= F(Thrust)
	
	MOVE.W	#10,(A0)+		* Vector up; dy=10.
	MOVE.W	#$6000,(A0)+		* dx=0

	MOVE.W	#$0,(A0)+		* Vector Back; dy=0
	NEG.W	D0
	AND.W	#$1FFF,D0
	OR.W	#$6000,D0
	MOVE.W	D0,(A0)+		* dx= -F(Thrust)

	MOVE.W	#$8040,(A0)+

	MOVE.L	A0,VG_PTR
	RTS


	PAGE
*Calculate Heading
*Angle is derived from Unit Vectors
*Determine Quadrant and Sector and Then Angle
*
*  D0		 AX1	 BX1	COMPARE		QUADRANT	ANGLES
*  ---           ---     ---    -------         --------        ------- 
*  000		  +	  +       Y>X		   1		 45-90 
*  001		  +	  +	  X>Y		   1		  0-45 
*  010		  +	  -	  Y>X		   4		270-315
*  011		  +	  -	  X>Y		   4		315-360
*  100		  -	  +	  Y>X		   2		 90-135
*  101		  -	  +	  X>Y		   2		135-180
*  110		  -	  -	  Y>X		   3		225-270
*  111		  -	  -	  X>Y		   3		180-225

HEADING
	CLR.L	D0		*D0 will form Branch address
	MOVE.W	(AX+UV2),D1	*D1 = AX = X
	BPL	HD10
	BSET	#2,D0			
	NEG.W	D1

* D1.W = ABS(X)
* D0(B2)=SIGN OF X
HD10	
	MOVE.W	(BX+UV2),D2	*D2 = BX = Y
	BPL	HD20
	BSET	#1,D0		*D0(B1)=SIGN OF Y
	NEG.W	D2

* D2.W = ABS(Y)
* D0(B1)=SIGN OF Y
HD20	
	CMP.W	D2,D1	       *ABS(X) > ABS(Y)?
	BCS	HD30	       *Unsigned compare, carry is clear if D1-D2 .GE. 0
	BSET	#0,D0

* D0(B0)=1 IF ABS(X) > ABS(Y)
HD30
	LSL.L	#2,D0		*Each subroutine address is 4 bytes long
	MOVEA.L	#ATNTBL,A0
	MOVEA.L	0(A0,D0),A0	*EA = #ATNTBL + 4*Index
*A0 contains the address of the subroutine that knows what sector the
*angle is in.	

	JSR	(A0)

*D0= ANGLE (BINARY*5), 360 deg = 708 H
	ASL.W	#1,D0			* multiply by 2	
	CMP.W	#$0E10,D0		*360 Deg should be 0 Deg
	BNE	HD40
	CLR.W	D0

HD40	MOVE.W	D0,A_HDN	* save Heading Angle
	
*Convert to BCD			*(BCD input in D0)
	MOVEQ.L	#16,D1		*Count for scaling
	BSR	BINBCD		*Output BCD in D2 (3600 = 360 Degrees)
	MOVE.W	D0,A_HDND	*Save BCD Heading * 10
*Continue
	PAGE
*------------------------------------------------------------------------------
*The heading will be displayed as a horizontally scrolled readout.
*
*Two angles will be displayed with a tick indicating the actual
*heading between the two closest angles that are multiples of 10 degrees.
*For example  193 will be displayed as:
*			
*			190		200
*			      ^
*
*The Tick will be stationary, the angles will move.
*
*The horizontal offset will be determined by the the LS digit + fraction.
*The LS digit will always be displayed as a '0' unless it is clipped.

*Figure out where to put it
DIS_HDN	
	MOVE.L	D0,D7		*Make a copy of D0;  100  10  1  .1 
	BSR	BCDBIN		*convert low two digits to Binary (result in D0)
	MOVE.W	#-$1F,D1	* -$1F is to center the number
	SUB.W	D0,D1		*D1 = Offset - (LS Digit + Fraction) 
	
* A0 will contain the current VG pointer
* D7 will contain the BCD angle
* D0, D1, and D2 are used as working registers
*Display Heading 
*JSRL VGHDN = Draw 'Heading', Heading Tick.
	MOVE.L	VG_PTR,A0

	MOVE.W	#$6360,(A0)+		*COLOR
	MOVE.W	#VJ_HDN,(A0)+		*JSRL VGHDN

*Vector to beginning of readout space
	MOVE.W	#$7300,(A0)+		*SCALE
	MOVE.W	#$10,(A0)+		*dy = 10
	AND.W	#$1FFF,D1
	MOVE.W	D1,(A0)+		*dx = -(LS Digit + Fraction + Offset)

*First Angle is on the Left 
*Digit Clipping
	LSR.W	#4,D7			*Get rid of fraction, result: 100 10 1 

	MOVE.L	D7,D0			*Make a copy

	AND.B	#$0F,D0			*mask it
	CMP.B	#$09,D0
	BNE	HDN50			*continue if not '9'

*If the LS digit is '9' then the first two digits are beyond the left edge
*and will be clipped
	MOVE.W	#0,(A0)+		* dy=0
	MOVE.W	#$30,(A0)+		* dx = 30 H, two character spaces

	CLR.W	D0			*Last digit is '0' anyway
	BSR	VW_1D			*view nybble

	BRA	HDN70			*continue

HDN50:	CMP.B	#$08,D0
	BNE	HDN60			*continue if not an '8'

*If the LS digit is an '8' then it is far enough to the right that only
*the first digit is clipped.
*	MOVE.W	#VJ_CHAR,(A0)+		*jsrl character space		
	MOVE.W	#$0,(A0)+
	MOVE.W	#24,(A0)+

	MOVE.L	D7,D0			* 100  10  1 

	AND.W	#$0F0,D0		*display D0:B 	

	BSR	VW_2D

	BRA	HDN70			*continue

*If LS digit is neither 8 nor 9, then display all three digits (Last is '0').
HDN60:	MOVE.W	D7,D0			* 100  10  1 
	AND.W	#$0FF0,D0
	BSR	VW_3D			*display 3 Digits

*Next Number Group
* Space it to the Right
HDN70:	MOVE.W	#0,(A0)+		*dy = 0
	MOVE.W	#$20,(A0)+		*dx = 20 H

*Increment the Tens Digit
	MOVE.L	D7,D0
	LSR.W	#4,D0			* 100 10
	MOVE.W	#$1,D1
	AND.W	#$0FFEF,SR		* Clear X Flag
	ABCD.B	D1,D0			

	AND.B	#$0FF,D0
	CMP.B	#$36,D0
	BNE	HDN75
	AND.W	#$0F,D7			* 360 degrees = 0 degrees	
	CLR.W	D0
HDN75:	MOVE.L	D7,D1			* 100  10  1 

*If the LS Digit is '1' then display the 2 MS digits (in D0) 
	AND.B	#$0F,D1
	CMP.B	#$1,D1
	BNE	HDN100

	BSR	VW_2D			* Two MS digits in D0
	
	BRA	HDN150			*continue

*If The LS Digit is '0', then display the first MS digit
HDN100:
	CMP.B	#0,D1
	BNE	HDN110

	LSR.W	#4,D0
	BSR	VW_1D

	BRA	HDN150		*continue	
*The LS digit is neither '0' nor '1' so display all three digits.
HDN110:
	LSL.W	#4,D0		* LS Digit is zero
	BSR	VW_3D		* three MS digits

HDN150:	
	MOVE.W	#$8040,(A0)+		*CENTER

	MOVE.L	A0,VG_PTR
	RTS
	PAGE
*------------------------------------------------------------------------------
ATNTBL	DC.L	ATN10,ATN20,ATN30,ATN40,ATN50,ATN60,ATN70,ATN80

*QUADRANT 1
ATN10:			
*				90 - ANGLE
	BSR 	YGTX		*Returns D0 = Angle
	SUB.W	#(90*5),D0	*angle-(90*5)
	NEG.W	D0		*(90*5)-angle
	RTS			*D0 CONTAINS ANGLE 45-90 DEGREES

ATN20:			
*				ANGLE 0 - 45 DEGREES
	BSR 	XGTY 		*Returns D0 = Angle
	RTS	HDN30		*D0 CONTAINS ANGLE 0-45 DEGREES
*
*------------------------------------------------------------------------------
*QUADRANT 4
ATN30:			
*				270 + ANGLE
	BSR 	YGTX		*Returns D0 = Angle
	ADD.W	#(270*5),D0
	RTS			*D0 CONTAINS ANGLE 270-315 DEGREES
*
ATN40:			
*				360 - ANGLE
  	BSR 	XGTY		*Returns D0 = Angle
	SUB.W	#(360*5),D0	*angle-(360*5)
	NEG.W	D0		*(360*5)-angle
	RTS			*D0 CONTAINS ANGLE 315-360 DEGREES
*------------------------------------------------------------------------------
*QUADRANT 2
ATN50:			
*				90 + ANGLE
	BSR 	YGTX		*Returns D0 = Angle
	ADD.W	#(90*5),D0
	RTS			*D0 CONTAINS ANGLE 90-135 DEGREES

ATN60:			
*				180 - ANGLE
	BSR 	XGTY		*Returns D0 = Angle
	SUB.W	#(180*5),D0	*angle-(180*5)
	NEG.W	D0		*(180*5)-angle	
	RTS			*D0 CONTAINS ANGLE 135-180 DEGREES
*------------------------------------------------------------------------------
*QUADRANT 3
ATN70:			
*				270 - ANGLE
	BSR 	YGTX		*Returns D0 = Angle
	SUB.W	#(270*5),D0	*angle-(270*5)
	NEG.W	D0		*(270*5)-angle
	RTS			*D0 CONTAINS ANGLE 225-270 DEGREES
*
ATN80:			
*				180 + ANGLE
	BSR 	XGTY		*Returns D0 = Angle
	ADD.W	#(180*5),D0
	RTS			*D0 CONTAINS ANGLE 180-225 DEGREES
*------------------------------------------------------------------------------
XGTY:	
* D1=X  [4000 MAX], D2=Y  [4000 MAX]
	SWAP	D2		
* D2=4000 XXXX [MAX]
	CLR.W	D2		
* D2=4000 0000 [MAX]
	ASR.L	#1,D2		
* D2=2000 0000 [MAX]
	TST.L	D1
	BNE	XG10
	MOVE.B	#1,D1		* make sure we do not divide by zero
XG10	DIVU	D1,D2		* Y/X
	ADD.W	#$80,D2		* Round off by adding 1/2 LSB and truncating
* D2 = XXXXnnnn
	AND.L	#$0FFFF,D2
* D2 = 0000nnnn
	LSR.W	#8,D2		
* D2= Index of angle = $80 max when x=y
	MOVEA.L	#ATAN,A0
	CLR.L	D0
	MOVE.B	0(A0,D2),D0
*D0 = Angle (*5)	
	RTS			

YGTX:	
* D1=X  [4000 MAX], D2=Y  [4000 MAX]
	SWAP	D1		
* D1=4000 XXXX [MAX]
	CLR.W	D1		
* D1=4000 0000 [MAX]
	ASR.L	#1,D1		
* D1=2000 0000 [MAX]
	TST.L	D2
	BNE	YG10
	MOVE.B	#1,D2		* make sure we do not divide by zero
YG10	DIVU	D2,D1		* X/Y
	ADD.W	#$80,D1		* Round off by adding 1/2 LSB and truncating
* D1 = XXXXnnnn
	AND.L	#$0FFFF,D1
* D1 = 0000nnnn
	LSR.W	#8,D1		
* D1= Index of angle = $80 max when x=y
	MOVEA.L	#ATAN,A0
	CLR.L	D0
	MOVE.B	0(A0,D1),D0
*D0 = Angle (*5)	
	RTS			

*ARCTANGENT TABLE (Angles are actually *5 for scaling)
ATAN:	DC.B	$00,$02,$04,$06,$08,$0B,$0D,$0F
	DC.B	$11,$14,$16,$18,$1A,$1C,$1F,$21
	DC.B	$23,$25,$28,$2A,$2C,$2E,$30,$32
	DC.B	$35,$37,$39,$3B,$3D,$3F,$41,$44
	DC.B	$46,$48,$4A,$4C,$4E,$50,$52,$54
	DC.B	$56,$58,$5A,$5C,$5E,$60,$62,$64
	DC.B	$66,$68,$6A,$6C,$6E,$70,$72,$74
	DC.B	$76,$78,$79,$7B,$7D,$7F,$81,$83
	DC.B	$84,$86,$88,$8A,$8B,$8D,$8F,$91
	DC.B	$92,$94,$96,$97,$99,$9B,$9C,$9E
	DC.B	$0A0,$0A1,$0A3,$0A4,$0A6,$0A7,$0A9,$0AB
	DC.B	$0AC,$0AE,$0AF,$0B1,$0B2,$0B4,$0B5,$0B6
	DC.B	$0B8,$0B9,$0BB,$0BC,$0BD,$0BF,$0C0,$0C2
	DC.B	$0C3,$0C4,$0C6,$0C7,$0C8,$0CA,$0CB,$0CC
	DC.B	$0CD,$0CF,$0D0,$0D1,$0D2,$0D4,$0D5,$0D6
	DC.B	$0D7,$0D8,$0DA,$0DB,$0DC,$0DD,$0DE,$0DF,$0E1
*------------------------------------------------------------------------------
	PAGE
*View one digit, low nybble in D0
*The program that calls it is responsible for setting up A0 = VG_PTR
*Uses D0, A0, A1
* 
VW_1D	MOVEA.L	#VGMSGA+2,A1	;offset because of blank

	AND.L	#$0F,D0
	LSL.L	#1,D0		*TWO BYTES/JSRL	
	MOVE.W	0(A1,D0),(A0)+

	RTS
*------------------------------------------------------------------------------
*View two digits, low byte in D0
*The program that calls it is responsible for setting up A0 = VG_PTR
*Uses D0, D1, A0, A1
* 
VW_2D	MOVEA.L	#VGMSGA+2,A1	*offset because of blank

	MOVE.W	D0,D1		*Make a copy
	AND.L	#$0F0,D0
	LSR.W	#3,D0		*High nybble first (two bytes/JSRL)	
	MOVE.W	0(A1,D0),(A0)+

	AND.L	#$0F,D1
	LSL.L	#1,D1
	MOVE.W	0(A1,D1),(A0)+

	RTS
*------------------------------------------------------------------------------
*View three digits in D0
*The program that calls it is responsible for setting up A0 = VG_PTR
*Uses D0, D1, A0, A1
* 
VW_3D	MOVEA.L	#VGMSGA+2,A1	*offset because of blank

	MOVE.W	D0,D1		*Make a copy

	AND.L	#$0F00,D0
	LSR.W	#7,D0
	MOVE.W	0(A1,D0),(A0)+		
	
	MOVE.L	D1,D0
	AND.L	#$0F0,D0
	LSR.W	#3,D0		
	MOVE.W	0(A1,D0),(A0)+

	AND.L	#$0F,D1
	LSL.L	#1,D1
	MOVE.W	0(A1,D1),(A0)+

	RTS
*------------------------------------------------------------------------------
*View four digits in D0
*The program that calls it is responsible for setting up A0 = VG_PTR
*Uses D0, D1, A0, A1
* 
VW_4D	MOVEA.L	#VGMSGA+2,A1	*offset because of blank

	MOVE.W	D0,D1		*Make a copy

	AND.L	#$0F000,D0
	LSR.L	#8,D0
	LSR.L	#3,D0
	MOVE.W	0(A1,D0),(A0)+

	MOVE.L	D1,D0
	AND.L	#$0F00,D0
	LSR.W	#7,D0
	MOVE.W	0(A1,D0),(A0)+		
	
	MOVE.L	D1,D0
	AND.L	#$0F0,D0
	LSR.W	#3,D0		
	MOVE.W	0(A1,D0),(A0)+

	AND.L	#$0F,D1
	LSL.L	#1,D1
	MOVE.W	0(A1,D1),(A0)+

	RTS
*------------------------------------------------------------------------------
*Convert Positive Binary to BCD
*Input binary in D0
*Number of Shifts in D1.L
*Output BCD in D0

*D2, D3, D4 are the BCD accumulators

*ABCD is byte instruction with Extend (only) 

BINBCD	CLR.L	D2
	CLR.L	D3
	CLR.W	D4
BN0	ROXL.W	#1,D0		*Get next Binary MSB	
	ABCD.B	D2,D2		*BCD = BCD * 2 (= Shift Left BCD)
	ABCD.B	D3,D3
	ABCD.B	D4,D4
	SUBQ.L	#1,D1
	BNE	BN0
* D2 contains least two BCD Digits, D3 middle, and D4 top two BCD Digits
	MOVE.L	D4,D0
	LSL.L	#8,D0
	MOVE.B	D3,D0
	LSL.L	#8,D0
	MOVE.B	D2,D0

	RTS
*------------------------------------------------------------------------------
*Convert 2 positive BCD Digits (contained in one byte) to Binary
*Input D0
*Output D0

BCDBIN
	AND.L	#$0FF,D0	*Mask off two digits
	MOVE.L	D0,D1		*make a copy
	LSR.W	#4,D0		*D1 contains most significant BCD Digit
	MULS	#10,D0		*D1 contains most significant BCD Digit * 10
	AND.B	#$0F,D1		*Add LSD
	ADD.W	D1,D0
	
	RTS			*D0 = 10 * MSD + LSD

	END
