



	TTL 'MATH'	* TomCat Math *

	INCLUDE 'COMN.ASM'

	XDEF	ROLL,PITCH,YAW,INITUV
	XDEF	POST,POST2,TPL1,TPL2,TPROJ,CONCAT,PRESUB
	XDEF	WC_GEN,WC_ROLL,WC_PTCH,WC_YAW,TICS
	XDEF	T_ROLL,T_PTCH,T_YAW
	XDEF	DOSTARS,MEND

	XREF	M_STARS
	
	SECTION PROGRAM
*------------------------------------------------------------------------------
* Initialise Unit Vectors at A0

* Calling Routine supplies:
*	A0 points to Unit Vector Block (not destroyed)
* Also uses:
*	A1
*	D0 

INITUV	MOVE.L	A0,A1
	MOVE.L	#-18,D0		*18 words to zero
ULOOP	CLR.W	(A1)+
	ADDQ.L	#1,D0
	BNE	ULOOP
	
	MOVE.W	#$4000,D0	*Put ONE where necessary
	MOVE.W	D0,AX(A0)
	MOVE.W	D0,BY(A0)
	MOVE.W	D0,CZ(A0)
	
	RTS
*-------------------------------------------------------------------------------
	PAGE
* Rotate Unit Vectors
* Roll
* TMS320: 140 uS versus 170 for a naked 68010
* Calling Routine Supplies:
*	A0 Points to Unit Vectors (and is not changed)
*	Don't change A1.
*	D0 = SIN
*	D1 = COS
*
* Does:
*	Ay' = Ay*COS - Az*SIN
*	Az' = Ay*SIN + Az*COS

*	By' = By*COS - Bz*SIN
*	Bz' = By*SIN + Bz*COS

*	Cy' = Cy*COS - Cz*SIN
*	Cz' = Cy*SIN + Cz*COS
*
*
ROLL:

	MOVE.L	A0,A2		* make a copy to use

* Upload A1 to m_ccuv
	LEA.L	m_ccuv,A3	* destination
	MOVE.W	#9-1,D2		* 9 words -1 for loop
TRLP	MOVE.W	(A2)+,(A3)+
	DBF	D2,TRLP

* Set up 320
	MOVE.W	#(m_ccuv-M_320)/2,m_uv
	MOVE.W	D0,m_sin
	MOVE.W	D1,m_cos

* Set Up Branch Instruction to ROLL Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_ROLL,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
TRLP2	BTST	#1,IN1
	BNE	TRLP2

* Download m_ccuv
	MOVE.L	A0,A2
	LEA.L	m_ccuv,A3
	MOVE.W	#9-1,D2		* 9 words -1 for loop
TRLP3	MOVE.W	(A3)+,(A2)+
	DBF	D2,TRLP3

	RTS
*-------------------------------------------------------------------------------
	PAGE
* Rotate Unit Vectors
* Pitch
* TMS320: 140 uS versus 170 for a naked 68010
* Calling Routine Supplies:
*	A0 Points to Unit Vectors (and is not changed)
* 	Don't change A1.
*	D0 = SIN
*	D1 = COS
*
*
*Does:
*	Az' = Az*COS - Ax*SIN
*	Ax' = Az*SIN + Ax*COS

*	Bz' = Bz*COS - Bx*SIN
*	Bx' = Bz*SIN + Bx*COS

*	Cz' = Cz*COS - Cx*SIN
*	Cx' = Cz*SIN + Cx*COS

PITCH:
	MOVE.L	A0,A2		* make a copy to use

* Upload A1 to m_ccuv
	LEA.L	m_ccuv,A3	* destination
	MOVE.W	#9-1,D2		* 9 words -1 for loop
TPLP	MOVE.W	(A2)+,(A3)+
	DBF	D2,TPLP

* Set up 320
	MOVE.W	#(m_ccuv-M_320)/2,m_uv
	MOVE.W	D0,m_sin
	MOVE.W	D1,m_cos

* Set Up Branch Instruction to PITCH Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_PITCH,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
TPLP2	BTST	#1,IN1
	BNE	TPLP2

* Download m_ccuv
	MOVE.L	A0,A2
	LEA.L	m_ccuv,A3
	MOVE.W	#9-1,D2		* 9 words -1 for loop
TPLP3	MOVE.W	(A3)+,(A2)+
	DBF	D2,TPLP3

	RTS
*-------------------------------------------------------------------------------
	PAGE
* Rotate Unit Vectors
* Yaw
* TMS320: 140 uS versus 170 for a naked 68010
* Calling Routine Supplies:
*	A0 Points to Unit Vectors (and is not changed)
* 	Don't change A1.
*	D0 = SIN
*	D1 = COS
*
* Does:
*	Ax' = Ax*COS - Ay*SIN
*	Ay' = Ax*SIN + Ay*COS

*	Bx' = Bx*COS - By*SIN
*	By' = Bx*SIN + By*COS

*	Cx' = Cx*COS - Cy*SIN
*	Cy' = Cx*SIN + Cy*COS
*
YAW:
	MOVE.L	A0,A2		* make a copy to use

* Upload A1 to m_ccuv
	LEA.L	m_ccuv,A3	* destination
	MOVE.W	#9-1,D2		* 9 words -1 for loop
TYLP:	MOVE.W	(A2)+,(A3)+
	DBF	D2,TYLP

* Set up 320
	MOVE.W	#(m_ccuv-M_320)/2,m_uv
	MOVE.W	D0,m_sin
	MOVE.W	D1,m_cos

* Set Up Branch Instruction to YAW Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_YAW,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
TYLP2	BTST	#1,IN1
	BNE	TYLP2

* Download m_ccuv
	MOVE.L	A0,A2
	LEA.L	m_ccuv,A3
	MOVE.W	#9-1,D2		* 9 words -1 for loop
TYLP3	MOVE.W	(A3)+,(A2)+
	DBF	D2,TYLP3

	RTS
*-------------------------------------------------------------------------------
	PAGE
* POSTADD #2
*
*	TOBJ (X) = AX*(X) + BX*(Y) + CX*(Z)
*	TOBJ (Y) = AY*(X) + BY*(Y) + CY*(Z)
*	TOBJ (Z) = AZ*(X) + BZ*(Y) + CZ*(Z)
*
* Calling Routine supplies:
*	 A0 points to Unit Vector Block
* 	 A4 points to the Object Input List
* 	 A5 points to Output List (For terrain objects, it is TOBJ)
*
* 	 D5 = # of points (use long word count)
*
* Also uses:
*	D0 = X 
* 	D1 = Y
* 	D2 = Z
*
* 	D6 = Dn * D6, also temp
* 	D7 is the Accumulator
*
* Takes about 115 uS/point
*
POST2
	MOVE.W	X(A4),D0	*D0 = X 
	MOVE.W	Y(A4),D1	*D1 = Y
	MOVE.W	Z(A4),D2	*D2 = Z

	CLR.L	D7		*clear accumulator
	MOVE.W	AX(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AX*(X)

	MOVE.W	BX(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AX*(X) + BX*(Y)

	MOVE.W	CX(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AX*(X) + BX*(Y) + CX*(Z)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOVE.W	D7,X(A5)	*TOBJ(X) = AX*(X) + BX*(Y) + CX*(Z) <<<<<<<<<<<
*----------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AY(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AY*(X)

	MOVE.W	BY(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AY*(X) + BY*(Y)

	MOVE.W	CY(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AY*(X) + BY*(Y) + CY*(Z)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOVE.W	D7,Y(A5)	*TOBJ(Y) = AY*(X) + BY*(Y) + CY*(Z) <<<<<<<<<<<
*----------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AZ(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AZ*(X)

	MOVE.W	BZ(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AZ*(X) + BZ*(Y)

	MOVE.W	CZ(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AZ*(X) + BZ*(Y) + CX*(Z)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOVE.W	D7,Z(A5)	*TOBJ(Z) = AZ*(X) + BZ*(Y) + CX*(Z) <<<<<<<<<<<
	
	ADDQ.L	#6,A4		*3 words * 2 bytes
	ADDQ.L	#6,A5		*3 words * 2 bytes

	SUBQ.L	#1,D5		*Decrement point counter
	BNE	POST2

	RTS
*-------------------------------------------------------------------------------
	PAGE
* POST ADD and PROJECT
*
*	XP = (AX * X) + (BX * Y) + (CX * Z) + XT
*	YP = (AY * X) + (BY * Y) + (CY * Z) + YT
*	ZP = (AZ * X) + (BZ * Y) + (CZ * Z) + ZT
*
*	X(PTBL)= YP/XP
*	Y(PTBL)= ZP/XP
*
* The projected points will be ready, starting at M_OUTL. 

* Calling Routine supplies:
* 	A0 points to Unit Vector Block
* 	Input Picture: The 320 picture address has been precalculated by the 
*		       calling program and put into m_tptr
*
* 	D5 = # of points (use long word count)
*
* FLASH! At this level, it takes only 50 us/point vs 
* 72 us/point for semiautomatic and 180 us/point naked.

* Do Full PostAdd
POST:

* A0 contains the Unit Vectors to use, so load them into 320 Ram.
	MOVE.L	#m_wc1,A3
	MOVE.W	#12-1,D0	* 9 Unit vector coefficients and Xt,Yt,Zt
TPO1:	MOVE.W	(A0)+,(A3)+
	DBF	D0,TPO1

* m_wc1 in the 320 Ram is (m_wc1-M_320)/2
	MOVE.W	#(m_wc1-M_320)/2,m_uv

* Input Picture: The 320 picture address has been precalculated by the calling 
* program and put into m_tptr

* The number of points is in D5
	MOVE.W	D5,m_pcount

* Point to the Output List
	MOVE.W	#(M_OUTL-M_320)/2,m_optr

* Set up Branch Instruction to POST4
	MOVE.W	#$0F900,M_PROG
	MOVE.W	#M_POST4,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
TPO2	BTST	#1,IN1
	BNE	TPO2

* The points are ready, starting at M_OUTL. 
	MOVE.L	#M_OUTL,A1

	RTS
*-------------------------------------------------------------------------------
	PAGE
* Terrain Object Projection:
* Translate Object to XP, YP, ZP and project
* Put projected object into PTBL
*	X(PTBL)= (TOBJ(Yn) + YP)/(TOBJ(Xn) + XP)
*	Y(PTBL)= (TOBJ(Zn) + ZP)/(TOBJ(Xn) + XP)
*
* Calling Routine supplies:
* 	D5 = # of points (use long word count)
* 	XP, YP, ZP = Translation coordinates
*
* Also Uses:
*	A0 = ADDR(TOBJ)  [Rotated-but-not-translated Terrain Object]
*	A1 = ADDR(PTBL)  [increments A1 as it is used] Output Point Table]
*
* 	D0,D1 used for projection divide: 
*		D1 = D1/D0
*		Inputs	D0 is 16 bits.
*			D1 is 32 bits.
*		Output	D1 is 32 bits.
*			Low word is quotient
*			High word is remainder
*	D2 = XP
*	D3 = YP
*	D4 = ZP
*
* Takes about 66 uS/point
*
TPROJ	MOVEA.W	#TOBJ,A0	A0=ADR(TOBJ)
	MOVEA.W	#PTBL,A1	A1=ADR(PTBL)

	MOVE.W	XP,D2
	MOVE.W	YP,D3
	MOVE.W	ZP,D4

TPL	MOVE.W	(A0)+,D0	*D0 = TOBJ(Xn)
	ADD.W	D2,D0		*D0 = TOBJ(Xn)+XP   (max is 7FFF)
	ASR.W	#1,D0		* max is 4000
	CMP.W	#0,D0		*Let's not accidentally divide by zero
	BNE	TPL1		
	MOVE.L	#1,D0

TPL1	CLR.L	D1
	MOVE.W	(A0)+,D1	*D1 = TOBJ(Yn)
	ADD.W	D3,D1		*D1 = TOBJ(Yn)+YP (16 bits, 7FFF max)
	SWAP	D1
	ASR.L	#3,D1		*D1 = TOBJ(Yn)+YP (32 bits, 1000 0000 max)

	DIVS	D0,D1		*D1 = D1/D0  ( max is 1000 0000/4000=4000)

	ASR.W	#5,D1		*(max is 200)
	MOVE.W	D1,(A1)+	**X(PTBL)= (TOBJ(Yn) + YP)/(TOBJ(Xn) + XP)

TPL2	CLR.L	D1
	MOVE.W	(A0)+,D1	*D1 = TOBJ(Zn)
	ADD.W	D4,D1		*D1 = TOBJ(Zn)+ZP (16 bits, 7FFF max)
	SWAP	D1
	ASR.L	#3,D1		*D1 = TOBJ(Zn)+ZP (32 bits, 1000 0000 max)

	DIVS	D0,D1		*D1 = D1/D0  ( max is 1000 0000/4000=4000)

	ASR.W	#5,D1		*(max is 200)
	MOVE.W	D1,(A1)+	*Y(PTBL)= (TOBJ(Zn) + ZP)/(TOBJ(Xn) + XP)

	SUBQ.L	#1,D5		*decrement point counter
	BNE	TPL		*loop until done

	RTS
*-------------------------------------------------------------------------------
	PAGE
* Concatenate Unit Vectors
* TMS320: 180 us versus 330 us with a naked 68010.

*
* Calling routine supplies:
*	A0 points to Resultant Unit Vectors
*	A1 points to Ship 1 Unit Vectors
*	A2 points to Ship 2 Unit Vectors
*

* Does:
*	[Ax Bx Cx]   [Ax1 Bx1 Cx1]   [Ax2 Ay2 Az2]
*	[Ay By Cy] = [Ay1 By1 Cy1] * [Bx2 By2 Bz2]
*	[Az Bz Cz]   [Az1 Bz1 Cz1]   [Cx2 Cy2 Cz2]
*
*	   Ship 1 looks at Ship 2
*
*
CONCAT 

* CCUV = UV1(UV) * [UV2(TPTR)]^
	
* A0 points to resultant Unit Vectors
* A1 points to UV1
* A2 points to UV2

* Upload A1 to m_uv1
	LEA.L	m_uv1,A3	* destination
	MOVE.W	#9-1,D0		* 9 words -1 for loop
TCLP:	MOVE.W	(A1)+,(A3)+
	DBF	D0,TCLP

* Upload A2 to m_uv2
	LEA.L	m_uv2,A3	* destination
	MOVE.W	#9-1,D0		* 9 words -1 for loop
TCLP1:	MOVE.W	(A2)+,(A3)+
	DBF	D0,TCLP1

* Set up 320
	MOVE.W	#(m_uv1-M_320)/2,m_uv
	MOVE.W	#(m_uv2-M_320)/2,m_tptr

* Set Up Branch Instruction to CONCAT Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_CONCAT,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
TCLP2	BTST	#1,IN1
	BNE	TCLP2

* Download m_ccuv
	LEA.L	m_ccuv,A3
	MOVE.W	#9-1,D0		* 9 words -1 for loop
TCLP3:	MOVE.W	(A3)+,(A0)+
	DBF	D0,TCLP3

	RTS

*-------------------------------------------------------------------------------
	PAGE
* PRESUBTRACT
*
*	XP = AX * (X-XT) + BX * (Y-YT) + CX * (Z-ZT)
*	YP = AY * (X-XT) + BY * (Y-YT) + CY * (Z-ZT)
*	ZP = AZ * (X-XT) + BZ * (Y-YT) + CZ * (Z-ZT)
*
* Calling Routine supplies:
*	A0 points to Unit Vectors
*	A1 points to Object Position List
*	
* Uses:
*	D0 = X-XT
*	D1 = Y-YT
*	D2 = Z-ZT
*
*	D6 = Dn * D6, also temp
*	D7 is the Accumulator
*
* Takes about 132 uS/point
*
PRESUB	
	MOVE.W	X(A1),D0
	SUB.W	XT(A0),D0	*D0 = X-XT
	MOVE.W	Y(A1),D1
	SUB.W	YT(A0),D1	*D1 = Y-YT
	MOVE.W	Z(A1),D2
	SUB.W	ZT(A0),D2	*D2 = Z-ZT

	CLR.L	D7		*clear accumulator
	MOVE.W	AX(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AX*(X-XT)

	MOVE.W	BX(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AX*(X-XT) + BX*(Y-YT)

	MOVE.W	CX(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AX*(X-XT) + BX*(Y-YT) + CX*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,XP		*XP = AX*(X-XT) + BX*(Y-YT) + CX*(Z-ZT) <<<<<<<
*------------------------------------------------------------------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AY(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AY*(X-XT)

	MOVE.W	BY(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AY*(X-XT) + BY*(Y-YT)

	MOVE.W	CY(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AY*(X-XT) + BY*(Y-YT) + CY*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,YP		*YP = AY*(X-XT) + BY*(Y-YT) + CY*(Z-ZT) <<<<<<<
*------------------------------------------------------------------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AZ(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AZ*(X-XT)

	MOVE.W	BZ(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AZ*(X-XT) + BZ*(Y-YT)

	MOVE.W	CZ(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AZ*(X-XT) + BZ*(Y-YT) + CZ*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,ZP		*ZP = AZ*(X-XT) + BZ*(Y-YT) + CZ*(Z-ZT) <<<<<<<

	RTS
*-----------------------------------------------------------------------------
* TICS
*	ALGORITHM: By Greg Rivera and Jed Margolin 

*	This algorithm gets around the problem that when you are in the ship,
*	rotations of 0.636 degrees (the smallest magic angle in 16 bits) are
*	too coarse.
*------------------------------------------------------------------------------
	PAGE
*ROLL TIC
* A0 points to primary Unit Vectors (which also contain Tic angles)
* D0 CONTAINS DELTA ANGLE FOR ROLL, +/- 78 MAX
T_ROLL  
	ADD.B	R_ANGLE(A0),D0			*D0=NEW R_ANGLE
*Is the angle greater than or equal to 78?
	CMP.B	#78,D0
	BGE	TR1	*yes
*Is the angle greater than or equal to 14?
	CMP.B	#14,D0
	BGE	TR2	*yes
*Is the angle greater than -14?
	CMP.B	#-14,D0
	BGT	TR3	*yes
*Is the angle greater than -78
	CMP.B	#-78,D0
	BGT	TR4	*yes	
*If it gets this far, the angle is less than or equal to -78:
	ADD.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) + 78
	MOVE.B	D0,R_ANGLE(A0)
	MOVE.W	#-1424,D0	*SIN -4.986 degrees
	MOVE.W	#16322,D1	*COS -4.986 degrees
	BSR	ROLL		*Rotate the Primary Set by -4.986 degrees
	RTS	
	
TR1 	SUB.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 78
	MOVE.B	D0,R_ANGLE(A0)
	MOVE.W	#1424,D0	*SIN 4.986 degrees
	MOVE.W	#16322,D1	*COS 4.986 degrees
	BSR	ROLL		*Rotate the Primary Set by 4.986 degrees
	RTS

TR2 	SUB.B	#14,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 14
	MOVE.B	D0,R_ANGLE(A0)
	MOVE.W	#256,D0		*SIN 0.895 degrees
	MOVE.W	#16382,D1	*COS 0.895 degrees
	BSR	ROLL		*Rotate the Primary Set by 0.895 degrees
	RTS

TR3 	MOVE.B	D0,R_ANGLE(A0)
	RTS	

TR4 	ADD.B	#14,D0		*   *_ANGLE(A0) = *_ANGLE(A0) + 14
	MOVE.B	D0,R_ANGLE(A0)
	MOVE.W	#-256,D0	*SIN -0.895 degrees
	MOVE.W	#16382,D1	*COS -0.895 degrees
	BSR	ROLL		*Rotate the Primary Set by -0.895 degrees
	RTS
*------------------------------------------------------------------------------
	PAGE
*PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 78 MAX
T_PTCH  
	ADD.B	P_ANGLE(A0),D0	*D0=NEW P_ANGLE(A0)
*Is the angle greater than or equal to 78?
	CMP.B	#78,D0
	BGE	TP1	*yes
*Is the angle greater than or equal to 14?
	CMP.B	#14,D0
	BGE	TP2	*yes
*Is the angle greater than -14?
	CMP.B	#-14,D0
	BGT	TP3	*yes
*Is the angle greater than -78
	CMP.B	#-78,D0
	BGT	TP4	*yes	
*If it gets this far, the angle is less than or equal to -78:
	ADD.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) + 78
	MOVE.B	D0,P_ANGLE(A0)
	MOVE.W	#-1424,D0	*SIN -4.986 degrees
	MOVE.W	#16322,D1	*COS -4.986 degrees
	BSR	PITCH		*Rotate the Primary Set by -4.986 degrees
	RTS	
	
TP1 	SUB.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 78
	MOVE.B	D0,P_ANGLE(A0)
	MOVE.W	#1424,D0	*SIN 4.986 degrees
	MOVE.W	#16322,D1	*COS 4.986 degrees
	BSR	PITCH		*Rotate the Primary Set by 4.986 degrees
	RTS

TP2 	SUB.B	#14,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 14
	MOVE.B	D0,P_ANGLE(A0)
	MOVE.W	#256,D0		*SIN 0.895 degrees
	MOVE.W	#16382,D1	*COS 0.895 degrees
	BSR	PITCH		*Rotate the Primary Set by 0.895 degrees
	RTS

TP3 	MOVE.B	D0,P_ANGLE(A0)
	RTS	

TP4 	ADD.B	#14,D0		*   *_ANGLE(A0) = *_ANGLE(A0) + 14
	MOVE.B	D0,P_ANGLE(A0)
	MOVE.W	#-256,D0	*SIN -0.895 degrees
	MOVE.W	#16382,D1	*COS -0.895 degrees
	BSR	PITCH		*Rotate the Primary Set by -0.895 degrees
	RTS
*------------------------------------------------------------------------------
	PAGE
*YAW TIC
* D0 CONTAINS DELTA ANGLE FOR YAW, +/- 78 MAX
T_YAW  
	ADD.B	Y_ANGLE(A0),D0		*D0=NEW Y_ANGLE(A0)
*Is the angle greater than or equal to 78?
	CMP.B	#78,D0
	BGE	TY1	*yes
*Is the angle greater than or equal to 14?
	CMP.B	#14,D0
	BGE	TY2	*yes
*Is the angle greater than -14?
	CMP.B	#-14,D0
	BGT	TY3	*yes
*Is the angle greater than -78
	CMP.B	#-78,D0
	BGT	TY4	*yes	
*If it gets this far, the angle is less than or equal to -78:
	ADD.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) + 78
	MOVE.B	D0,Y_ANGLE(A0)
	MOVE.W	#-1424,D0	*SIN -4.986 degrees
	MOVE.W	#16322,D1	*COS -4.986 degrees
	BSR	YAW		*Rotate the Primary Set by -4.986 degrees
	RTS	
	
TY1 
	SUB.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 78
	MOVE.B	D0,Y_ANGLE(A0)
	MOVE.W	#1424,D0	*SIN 4.986 degrees
	MOVE.W	#16322,D1	*COS 4.986 degrees
	BSR	YAW		*Rotate the Primary Set by 4.986 degrees
	RTS

TY2 	SUB.B	#14,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 14
	MOVE.B	D0,Y_ANGLE(A0)
	MOVE.W	#256,D0		*SIN 0.895 degrees
	MOVE.W	#16382,D1	*COS 0.895 degrees
	BSR	YAW		*Rotate the Primary Set by 0.895 degrees
	RTS

TY3 	MOVE.B	D0,Y_ANGLE(A0)
	RTS	

TY4 	
	ADD.B	#14,D0		*   *_ANGLE(A0) = *_ANGLE(A0) + 14
	MOVE.B	D0,Y_ANGLE(A0)
	MOVE.W	#-256,D0	*SIN -0.895 degrees
	MOVE.W	#16382,D1	*COS -0.895 degrees
	BSR	YAW		*Rotate the Primary Set by -0.895 degrees
	RTS
*------------------------------------------------------------------------------
	PAGE
* Generate the Working Copy Unit Vectors
* Calling Routine supplies:
* 	A0 is the Working Set [UV2] 
* 	A1 is the Primary Set of Unit Vectors [UV1] 
* Uses lots of Registers
* Copies UV1 to UV2 and rotates by Roll, Pitch, and Yaw Tics.
* Takes about 620 uS, worst case, which is most of the time
* Seems to take about 440 uS
WC_GEN  
*COPY UNIT VECTORS FROM PRIMARY SET TO WORKING SET [ ex. UV1 TO UV2]

	MOVE.L	A0,A2
	MOVE.L	A1,A3
	MOVE.B	#$9,D0			*9 WORDS
WC10	MOVE.W	(A3)+,(A2)+
	SUBQ.B	#1,D0
	BNE	WC10	

*GENERATE THE WORKING COPY 
*ROLL WORKING COPY
WC_ROLL 				
	MOVEA.L	#TICS,A3
	CLR.L	D0
	MOVE.B	R_ANGLE(A1),D0
	CMP.B	#0,D0
	BEQ	WC_PTCH			* If angle is zero, no rotate
	BLT	CX10			* Negative angle
	ASL.B	#2,D0			* Positive angle (2 words = 4 bytes)
	ADDA	D0,A3			* A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	MOVE.W	2(A3),D1		*COS

	BSR	ROLL			* ROLL working copy (in A0) by (SIN,COS)
	BRA	WC_PTCH

CX10	NEG.B	D0			* Negative angle (make it positive)
	ASL.B	#2,D0
	ADDA	D0,A3			*A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	NEG.W	D0			*-SIN	
	MOVE.W	2(A3),D1		*COS

	BSR	ROLL		* ROLL working copy (in A0) by (-SIN,COS)

*PITCH WORKING COPY
WC_PTCH 				
	MOVEA.L	#TICS,A3
	CLR.L	D0
	MOVE.B	P_ANGLE(A1),D0
	CMP.B	#0,D0
	BEQ	WC_YAW			* If angle is zero, no rotate
	BLT	CX11			* Negative angle
	ASL.B	#2,D0			* Positive angle (2 words = 4 bytes)
	ADDA	D0,A3			* A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	MOVE.W	2(A3),D1		*COS

	BSR	PITCH		*PITCH working copy (in A0) by (SIN,COS)
	BRA	WC_YAW

CX11	NEG.B	D0			* Negative angle (make it positive)
	ASL.B	#2,D0
	ADDA	D0,A3			*A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	NEG.W	D0			*-SIN	
	MOVE.W	2(A3),D1		*COS

	BSR	PITCH		* PITCH working copy (in A0) by (-SIN,COS)

*YAW WORKING COPY
WC_YAW 				
	MOVEA.L	#TICS,A3
	CLR.L	D0
	MOVE.B	Y_ANGLE(A1),D0
	CMP.B	#0,D0
	BEQ	CX13			* If angle is zero, no rotate
	BLT	CX12			* Negative angle
	ASL.B	#2,D0			* Positive angle (2 words = 4 bytes)
	ADDA	D0,A3			* A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	MOVE.W	2(A3),D1		*COS

	BSR	YAW		*YAW working copy (in A0) by (SIN,COS)
	BRA	CX13

CX12	NEG.B	D0			* Negative angle (make it positive)
	ASL.B	#2,D0
	ADDA	D0,A3			*A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	NEG.W	D0			*-SIN	
	MOVE.W	2(A3),D1		*COS

	BSR	YAW		* YAW working copy (in A0) by (-SIN,COS)

CX13	RTS

	PAGE
* SINE COSINE FOR MAGIC TICS, 4000(16384.) IS UNITY
TICS                            
*				 #    DEGREES SINE    COSINE
	DC.W	0,16384		*# 0	0	0      16384	
        DC.W   18,16384      	*# 1   .064    18      16384 
        DC.W   37,16384      	*# 2   .128    37      16384 
        DC.W   55,16384      	*# 3   .192    55      16384 
        DC.W   73,16384      	*# 4   .256    73      16384 
        DC.W   91,16384      	*# 5   .32     91      16384 
        DC.W   110,16384      	*# 6   .384    110     16384 
        DC.W   128,16384      	*# 7   .447    128     16384 
        DC.W   146,16383      	*# 8   .511    146     16383 
        DC.W   165,16383      	*# 9   .575    165     16383 
        DC.W   183,16383      	*# 10  .639    183     16383 
        DC.W   201,16383      	*# 11  .703    201     16383 
        DC.W   219,16383      	*# 12  .767    219     16383 
        DC.W   238,16382      	*# 13  .831    238     16382 
        DC.W   256,16382      	*# 14  .895    256     16382 
        DC.W   274,16382      	*# 15  .959    274     16382 
        DC.W   292,16381      	*# 16  1.023   292     16381 
        DC.W   311,16381      	*# 17  1.087   311     16381 
        DC.W   329,16381      	*# 18  1.151   329     16381 
        DC.W   347,16380      	*# 19  1.215   347     16380 
        DC.W   366,16380      	*# 20  1.278   366     16380 
        DC.W   384,16380      	*# 21  1.342   384     16380 
        DC.W   402,16379      	*# 22  1.406   402     16379 
        DC.W   420,16379      	*# 23  1.47    420     16379 
        DC.W   439,16378      	*# 24  1.534   439     16378 
        DC.W   457,16378      	*# 25  1.598   457     16378 
        DC.W   475,16377      	*# 26  1.662   475     16377 
        DC.W   493,16377      	*# 27  1.726   493     16377 
        DC.W   512,16376      	*# 28  1.79    512     16376 
        DC.W   530,16375      	*# 29  1.854   530     16375 
        DC.W   548,16375      	*# 30  1.918   548     16375 
        DC.W   567,16374      	*# 31  1.982   567     16374 
        DC.W   585,16374      	*# 32  2.046   585     16374 
        DC.W   603,16373      	*# 33  2.109   603     16373 
        DC.W   621,16372      	*# 34  2.173   621     16372 
        DC.W   640,16372      	*# 35  2.237   640     16372 
        DC.W   658,16371      	*# 36  2.301   658     16371 
        DC.W   676,16370      	*# 37  2.365   676     16370 
        DC.W   694,16369      	*# 38  2.429   694     16369 
        DC.W   713,16368      	*# 39  2.493   713     16368 
        DC.W   731,16368	*# 40  2.557   731     16368 
        DC.W   749,16367      	*# 41  2.621   749     16367 
        DC.W   767,16366      	*# 42  2.685   767     16366 
        DC.W   786,16365      	*# 43  2.749   786     16365 
        DC.W   804,16364      	*# 44  2.813   804     16364 
        DC.W   822,16363      	*# 45  2.877   822     16363 
        DC.W   840,16362      	*# 46  2.94    840     16362 
        DC.W   859,16361      	*# 47  3.004   859     16361 
        DC.W   877,16361      	*# 48  3.068   877     16361 
        DC.W   895,16360      	*# 49  3.132   895     16360 
        DC.W   913,16359      	*# 50  3.196   913     16359 
        DC.W   932,16357      	*# 51  3.26    932     16357 
        DC.W   950,16356      	*# 52  3.324   950     16356 
        DC.W   968,16355      	*# 53  3.388   968     16355 
        DC.W   986,16354      	*# 54  3.452   986     16354 
        DC.W   1005,16353     	*# 55  3.516   1005    16353 
        DC.W   1023,16352     	*# 56  3.58    1023    16352 
        DC.W   1041,16351     	*# 57  3.644   1041    16351 
        DC.W   1059,16350     	*# 58  3.708   1059    16350 
        DC.W   1078,16349     	*# 59  3.771   1078    16349 
        DC.W   1096,16347    	*# 60  3.835   1096    16347 
        DC.W   1114,16346     	*# 61  3.899   1114    16346 
        DC.W   1132,16345     	*# 62  3.963   1132    16345 
        DC.W   1151,16344     	*# 63  4.027   1151    16344 
        DC.W   1169,16342     	*# 64  4.091   1169    16342 
        DC.W   1187,16341     	*# 65  4.155   1187    16341 
        DC.W   1205,16340     	*# 66  4.219   1205    16340 
        DC.W   1224,16338     	*# 67  4.283   1224    16338 
        DC.W   1242,16337     	*# 68  4.347   1242    16337 
        DC.W   1260,16335     	*# 69  4.411   1260    16335 
        DC.W   1278,16334     	*# 70  4.475   1278    16334 
        DC.W   1296,16333     	*# 71  4.539   1296    16333 
        DC.W   1315,16331     	*# 72  4.602   1315    16331 
        DC.W   1333,16330     	*# 73  4.666   1333    16330 
        DC.W   1351,16328     	*# 74  4.73    1351    16328 
        DC.W   1369,16327     	*# 75  4.794   1369    16327 
        DC.W   1388,16325     	*# 76  4.858   1388    16325 
        DC.W   1406,16324     	*# 77  4.922   1406    16324 
        DC.W   1424,16322     	*# 78  4.986   1424    16322 
*-------------------------------------------------------------------------------
	PAGE
* Do the Stars
DOSTARS:

* Download the Unit Vectors
	MOVE.W	#UV2,A0			* Ship 1 working copy
	MOVE.L	#m_wc1,A2
	MOVE.W	#9-1,D0			* 9 coefficients
DS1	MOVE.W	(A0)+,(A2)+
	DBF	D0,DS1

* m_wc1 in the 320 Ram is (m_wc1-M_320)/2
	MOVE.W	#(m_wc1-M_320)/2,m_uv

* Input Picture
	MOVE.W	#M_STARS,m_tptr		

* Number of Stars
	MOVE.W	#32,m_pcount

* Point to Output List
	MOVE.W	#(M_OUTL-M_320)/2,m_optr
	
* Set up Branch Instruction to SPRESUB
	MOVE.W	#$0F900,M_PROG
	MOVE.W	#M_SPRESUB,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
DS2	BTST	#1,IN1
	BNE	DS2

* The points are ready, starting at M_OUTL. # of Pts are in m_ocount
	MOVE.L	#M_OUTL,A0
	MOVE.W	m_ocount,D6

* Check if there are any
	BEQ	DS4

* Format and add to VG Buffer
	MOVE.L	VG_PTR,A1
	MOVE.W	#$7200,(A1)+
	MOVE.W	#$6380,(A1)+

DS3	MOVE.W	Y(A0),D0		* DY
	AND.W	#$1FFF,D0
	MOVE.W	D0,(A1)+

	MOVE.W	X(A0),D0		* DX
	AND.W	#$1FFF,D0	
	MOVE.W	D0,(A1)+

	MOVE.L	#$000006000,(A1)+	* Dot

	MOVE.W	#$8040,(A1)+
	ADDQ.L	#$4,A0
	SUBQ.W	#1,D6			* any points left?
	BNE	DS3

	MOVE.L	A1,VG_PTR

DS4	RTS
*===============================================================================
*===============================================================================
SW	SET	1		* SWITCH =1 FOR NAKED MATH

	IFNE	SW

	PAGE
* Naked 68010 Math routines (no TMS320)

	XDEF	NROLL,NPITCH,NYAW
	XDEF	NT_ROLL,NT_PTCH,NT_YAW,NWC_GEN
	XDEF	NPOST,NCONCAT,NPRESUB
*------------------------------------------------------------------------------
* Rotate Unit Vectors
* Naked Roll, 68010 only
* Calling Routine Supplies:
*	A0 Points to Unit Vectors (and is not changed)
*	D0 = SIN
*	D1 = COS
*
* Also uses:
*	D2 = AY, BY, CY
*	D3 = AZ, BZ, CZ
*	D4 = $2000	for rounding
*	D5 = Dn * D5
*	D6 = Accumulator
*
* Does:
*	Ay' = Ay*COS - Az*SIN
*	Az' = Ay*SIN + Az*COS

*	By' = By*COS - Bz*SIN
*	Bz' = By*SIN + Bz*COS

*	Cy' = Cy*COS - Cz*SIN
*	Cz' = Cy*SIN + Cz*COS
*
* Takes about 170 uS
*
NROLL
	MOVE.L	#$2000,D4	*For Rounding

	MOVE.W	AY(A0),D2
	MOVE.W	AZ(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = AY*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = AY*COS - AZ*SIN
	ADD.L	D4,D6		*D6 = AY*COS - AZ*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,AY(A0)	*AY'= AY*COS - AZ*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = AY*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = AY*SIN + AZ*COS
	ADD.L	D4,D6		*D6 = AY*SIN + AZ*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,AZ(A0)	*AZ' = AY*SIN + AZ*COS + 1/2 LSB <<<<<<<<<<<<<<
*---------
	MOVE.W	BY(A0),D2
	MOVE.W	BZ(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = BY*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = BY*COS - BZ*SIN
	ADD.L	D4,D6		*D6 = BY*COS - BZ*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,BY(A0)	*BY'= BY*COS - BZ*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = BY*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = BY*SIN + BZ*COS
	ADD.L	D4,D6		*D6 = BY*SIN + BZ*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,BZ(A0)	*BZ' = BY*SIN + BZ*COS + 1/2 LSB <<<<<<<<<<<<<<
*--------
	MOVE.W	CY(A0),D2
	MOVE.W	CZ(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = CY*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = CY*COS - CZ*SIN
	ADD.L	D4,D6		*D6 = CY*COS - CZ*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,CY(A0)	*CY'= CY*COS - CZ*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = CY*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = CY*SIN + CZ*COS
	ADD.L	D4,D6		*D6 = CY*SIN + CZ*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,CZ(A0)	*CZ' = CY*SIN + CZ*COS + 1/2 LSB <<<<<<<<<<<<<<
	
	RTS
*-------------------------------------------------------------------------------
	PAGE
* Rotate Unit Vectors
* Naked Pitch, 68010 only
* Calling Routine Supplies:
*	A0 Points to Unit Vectors (and is not changed)
*	D0 = SIN
*	D1 = COS
*
*Also Uses:
*	D2 = AZ,BZ,CZ
*	D3 = AX,BX,CX
*	D4 = $2000	for rounding
*	D5 = Dn * D5
*	D6 = Accumulator
*
*Does:
*	Az' = Az*COS - Ax*SIN
*	Ax' = Az*SIN + Ax*COS

*	Bz' = Bz*COS - Bx*SIN
*	Bx' = Bz*SIN + Bx*COS

*	Cz' = Cz*COS - Cx*SIN
*	Cx' = Cz*SIN + Cx*COS

* Takes about 170 uS
* Rotate Unit Vectors
*
NPITCH:
	MOVE.L	#$2000,D4	*For Rounding

	MOVE.W	AZ(A0),D2
	MOVE.W	AX(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = AZ*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = AZ*COS - AX*SIN
	ADD.L	D4,D6		*D6 = AZ*COS - AX*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,AZ(A0)	*AZ'= AZ*COS - AX*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = AZ*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = AZ*SIN + AX*COS
	ADD.L	D4,D6		*D6 = AZ*SIN + AX*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,AX(A0)	*AX' = AZ*SIN + AX*COS + 1/2 LSB <<<<<<<<<<<<<<
*---------
	MOVE.W	BZ(A0),D2
	MOVE.W	BX(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = BZ*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = BZ*COS - BX*SIN
	ADD.L	D4,D6		*D6 = BZ*COS - BX*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,BZ(A0)	*BZ'= BZ*COS - BX*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = BZ*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = BZ*SIN + BX*COS
	ADD.L	D4,D6		*D6 = BZ*SIN + BX*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,BX(A0)	*BX' = BZ*SIN + BX*COS + 1/2 LSB <<<<<<<<<<<<<<
*--------
	MOVE.W	CZ(A0),D2
	MOVE.W	CX(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = CZ*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = CZ*COS - CX*SIN
	ADD.L	D4,D6		*D6 = CZ*COS - CX*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,CZ(A0)	*CZ'= CZ*COS - CX*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = CZ*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = CZ*SIN + CX*COS
	ADD.L	D4,D6		*D6 = CZ*SIN + CX*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,CX(A0)	*CX' = CZ*SIN + CX*COS + 1/2 LSB <<<<<<<<<<<<<<
	
	RTS
*-------------------------------------------------------------------------------
	PAGE
* Rotate Unit Vectors
* Naked Yaw, 68010 only
* Calling Routine Supplies:
*	A0 Points to Unit Vectors (and is not changed)
*	D0 = SIN
*	D1 = COS
*
* Also Uses:
*	D2 = AX,BX,CX
*	D3 = AY,BY,CY
*	D4 = $2000	for rounding
*	D5 = Dn * D5
*	D6 = Accumulator
*
* Does:
*	Ax' = Ax*COS - Ay*SIN
*	Ay' = Ax*SIN + Ay*COS

*	Bx' = Bx*COS - By*SIN
*	By' = Bx*SIN + By*COS

*	Cx' = Cx*COS - Cy*SIN
*	Cy' = Cx*SIN + Cy*COS
*
* Takes about 170 uS
*
NYAW:
	MOVE.L	#$2000,D4	*For Rounding

	MOVE.W	AX(A0),D2
	MOVE.W	AY(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = AX*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = AX*COS - AY*SIN
	ADD.L	D4,D6		*D6 = AX*COS - AY*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,AX(A0)	*AX'= AX*COS - AY*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = AX*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = AX*SIN + AY*COS
	ADD.L	D4,D6		*D6 = AX*SIN + AY*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,AY(A0)	*AY' = AX*SIN + AY*COS + 1/2 LSB <<<<<<<<<<<<<<
*---------
	MOVE.W	BX(A0),D2
	MOVE.W	BY(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = BX*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = BX*COS - BY*SIN
	ADD.L	D4,D6		*D6 = BX*COS - BY*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,BX(A0)	*BX'= BX*COS - BY*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = BX*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = BX*SIN + BY*COS
	ADD.L	D4,D6		*D6 = BX*SIN + BY*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,BY(A0)	*BY' = BX*SIN + BY*COS + 1/2 LSB <<<<<<<<<<<<<<
*--------
	MOVE.W	CX(A0),D2
	MOVE.W	CY(A0),D3

	MOVE.L	D2,D6
	MULS	D1,D6		*D6 = CX*COS
	MOVE.L	D3,D5
	MULS	D0,D5
	SUB.L	D5,D6		*D6 = CX*COS - CY*SIN
	ADD.L	D4,D6		*D6 = CX*COS - CY*SIN + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,CX(A0)	*CX'= CX*COS - CY*SIN + 1/2 LSB <<<<<<<<<<<<<<<

	MOVE.L	D2,D6
	MULS	D0,D6		*D6 = CX*SIN
	MOVE.L	D3,D5
	MULS	D1,D5		
	ADD.L	D5,D6		*D6 = CX*SIN + CY*COS
	ADD.L	D4,D6		*D6 = CX*SIN + CY*COS + 1/2 LSB
	ASL.L	#2,D6		*Adjust Binary Point
	SWAP	D6

	MOVE.W	D6,CY(A0)	*CY' = CX*SIN + CY*COS + 1/2 LSB <<<<<<<<<<<<<<
	
	RTS
*-------------------------------------------------------------------------------
	PAGE
* POST2 is already naked
*-------------------------------------------------------------------------------
* POST ADD and PROJECT
*
*	XP = (AX * X) + (BX * Y) + (CX * Z) + XT
*	YP = (AY * X) + (BY * Y) + (CY * Z) + YT
*	ZP = (AZ * X) + (BZ * Y) + (CZ * Z) + ZT
*
*	X(PTBL)= YP/XP
*	Y(PTBL)= ZP/XP
*
* Calling Routine supplies:
* 	A0 points to Unit Vector Block
* 	A1 points to the Object Input List (Object Picture Library)
* 	A2 points to Output List (Output Table of Projected Points [PTBL])
*
* 	D5 = # of points (use long word count)
*
* Also uses:
*	D0,D1 used for projection divide: 
*		D1 = D1/D0
*		Inputs	D0 is 16 bits.
*			D1 is 32 bits.
*		Output	D1 is 32 bits.
*			Low word is quotient
*			High word is remainder
*
* 	A4 is used to save XP
* 	A5 is used to save YP 
*
* 	D0 = X 
* 	D1 = Y
* 	D2 = Z
*
* 	D5 = point counter
* 	D6 = Dn * D6, also temp
* 	D7 is the Accumulator
*
* Takes about 180 uS/point (40 uS is just for the two raw divides)
* For Reference only; may not be completely compatible with TMS320 section
NPOST:	
	MOVE.W	X(A1),D0	*D0 = X 
	MOVE.W	Y(A1),D1	*D1 = Y
	MOVE.W	Z(A1),D2	*D2 = Z

	CLR.L	D7		*clear accumulator
	MOVE.W	AX(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AX*(X)

	MOVE.W	BX(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AX*(X) + BX*(Y)

	MOVE.W	CX(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AX*(X) + BX*(Y) + CX*(Z)
	
	MOVE.W	XT(A0),D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6
	ADD.L	D6,D7		*D7= AX*(X) + BX*(Y) + CX*(Z) + XT

	MOVE.L	D7,A4		*A4 is used to store XP (32 bits)
*				 XP = AX*(X) + BX*(Y) + CX*(Z) + XT <<<<<<<<<<<
*----------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AY(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AY*(X)

	MOVE.W	BY(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AY*(X) + BY*(Y)

	MOVE.W	CY(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AY*(X) + BY*(Y) + CY*(Z)

	MOVE.W	YT(A0),D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6
	ADD.L	D6,D7		*D7= AY*(X) + BY*(Y) + CY*(Z) + YT

	MOVE.L	D7,A5		*A5 is used to store YP (32 bits)
*				 YP = AY*(X) + BY*(Y) + CY*(Z) <<<<<<<<<<<
*----------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AZ(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AZ*(X)

	MOVE.W	BZ(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AZ*(X) + BZ*(Y)

	MOVE.W	CZ(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= ZP = AZ*(X) + BZ*(Y) + CX*(Z)<<<<<<<<<<<

	MOVE.W	ZT(A0),D6
	SWAP	D6
	CLR.W	D6
	ASR.L	#2,D6
	ADD.L	D6,D7		*D7= ZP = AZ*(X) + BZ*(Y) + CX*(Z) + ZT <<<<<<<<

PERS	
	MOVE.L	A4,D0		*D0 = XP is 32 bits (1000 0000 max)
	ASL.L	#2,D0		
	SWAP	D0		*D0 = XP = 4000 max

	MOVE.L	A5,D1		*D1 = YP = 1000 0000 max

	DIVS	D0,D1		*D1 = YP/XP = 16 bits = 4000 max
	ASR.W	#5,D1		*D1 = 200 max

	MOVE.W	D1,X(A2)	*X(PTBL) = SX = K*YP/XP

	DIVS	D0,D7		*D7 = ZP/XP = 16 bits = 4000 max
	ASR.W	#5,D7		*D7 = 200 max

	MOVE.W	D7,Y(A2)	*Y(PTBL) = SY = K*ZP/XP

	ADDQ.L	#6,A1		*3 words * 2 bytes for input table
	ADDQ.L	#4,A2		*2 words * 2 bytes for output table

	SUBQ.L	#1,D5		*Decrement point counter
	BNE	NPOST

	RTS			*The Transformed and Projected Object is
*				 waiting in PTBL to be formatted for the
*				 Vector Generator.		
*-------------------------------------------------------------------------------
	PAGE
* Terrain Object Projection:
* Translate Object to XP, YP, ZP and project
* Put projected object into PTBL
*	X(PTBL)= (TOBJ(Yn) + YP)/(TOBJ(Xn) + XP)
*	Y(PTBL)= (TOBJ(Zn) + ZP)/(TOBJ(Xn) + XP)
*
* TPROJ is already naked
*===============================================================================
*===============================================================================
*Concatenate Unit Vectors
* Naked Concatenate (68010 only)
* Calling routine supplies:
*	A0 points to Resultant Unit Vectors
*	A1 points to Ship 1 Unit Vectors
*	A2 points to Ship 2 Unit Vectors
*
* Also uses:
*	D0 = AX2, AY2, AZ2
*	D1 = BX2, BY2, BZ2
*	D2 = CX2, CY2, CZ2
*
*	D6 = Dn * D6
*	D7 = Accumulator
*
*	[Ax Bx Cx]   [Ax1 Bx1 Cx1]   [Ax2 Ay2 Az2]
*	[Ay By Cy] = [Ay1 By1 Cy1] * [Bx2 By2 Bz2]
*	[Az Bz Cz]   [Az1 Bz1 Cz1]   [Cx2 Cy2 Cz2]
*
*	   Ship 1 looks at Ship 2
*
* Takes about 330 uS
*
*AX = (AX1 * AX2) + (BX1 * BX2) + (CX1 * CX2)
NCONCAT 
	MOVE.W	AX(A2),D0	*Set up Registers
	MOVE.W	BX(A2),D1
	MOVE.W	CX(A2),D2

	CLR.L	D7		*Clear Accumulator
	MOVE.W	AX(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AX1*AX2)
	MOVE.W	BX(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AX1*AX2)+(BX1*BX2)
	MOVE.W	CX(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AX1*AX2)+(BX1*BX2)+(CX1*CX2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,AX(A0)	*AX=(AX1*AX2)+(BX1*BX2)+(CX1*CX2) <<<<<<<<<<<<<

*AY = (AY1 * AX2) + (BY1 * BX2) + (CY1 * CX2)
	CLR.L	D7		*Clear Accumulator
	MOVE.W	AY(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AY1*AX2)
	MOVE.W	BY(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AY1*AX2)+(BY1*BX2)
	MOVE.W	CY(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AY1*AX2)+(BY1*BX2)+(CY1*CX2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,AY(A0)	*AY=(AY1*AX2)+(BY1*BX2)+(CY1*CX2) <<<<<<<<<<<<<

*AZ = (AZ1 * AX2) + (BZ1 * BX2) + (CZ1 * CX2)
	CLR.L	D7		*Clear Accumulator
	MOVE.W	AZ(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AZ1*AX2)
	MOVE.W	BZ(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AZ1*AX2)+(BZ1*BX2)
	MOVE.W	CZ(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AZ1*AX2)+(BZ1*BX2)+(CZ1*CX2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,AZ(A0)	*AZ=(AZ1*AX2)+(BZ1*BX2)+(CZ1*CX2) <<<<<<<<<<<<<
*------------------------------------------------------------------------------
*BX = (AX1 * AY2) + (BX1 * BY2) + (CX1 * CY2)
	MOVE.W	AY(A2),D0	*Set up Registers
	MOVE.W	BY(A2),D1
	MOVE.W	CY(A2),D2

	CLR.L	D7		*Clear Accumulator
	MOVE.W	AX(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AX1*AY2)
	MOVE.W	BX(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AX1*AY2)+(BX1*BY2)
	MOVE.W	CX(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AX1*AY2)+(BX1*BY2)+(CX1*CY2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,BX(A0)	*BX=(AX1*AY2)+(BX1*BY2)+(CX1*CY2) <<<<<<<<<<<<<

*BY = (AY1 * AY2) + (BY1 * BY2) + (CY1 * CY2)
	CLR.L	D7		*Clear Accumulator
	MOVE.W	AY(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AY1*AY2)
	MOVE.W	BY(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AY1*AY2)+(BY1*BY2)
	MOVE.W	CY(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AY1*AY2)+(BY1*BY2)+(CY1*CY2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,BY(A0)	*BY=(AY1*AY2)+(BY1*BY2)+(CY1*CY2) <<<<<<<<<<<<<

*BZ = (AZ1 * AY2) + (BZ1 * BY2) + (CZ1 * CY2)
	CLR.L	D7		*Clear Accumulator
	MOVE.W	AZ(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AZ1*AY2)
	MOVE.W	BZ(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AZ1*AY2)+(BZ1*BY2)
	MOVE.W	CZ(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AZ1*AY2)+(BZ1*BY2)+(CZ1*CY2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,BZ(A0)	*BZ=(AZ1*AY2)+(BZ1*BY2)+(CZ1*CY2) <<<<<<<<<<<<<
*------------------------------------------------------------------------------
*CX = (AX1 * AZ2) + (BX1 * BZ2) + (CX1 * CZ2)
	MOVE.W	AZ(A2),D0	*Set up Registers
	MOVE.W	BZ(A2),D1
	MOVE.W	CZ(A2),D2

	CLR.L	D7		*Clear Accumulator
	MOVE.W	AX(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AX1*AZ2)
	MOVE.W	BX(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AX1*AZ2)+(BX1*BZ2)
	MOVE.W	CX(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AX1*AZ2)+(BX1*BZ2)+(CX1*CZ2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,CX(A0)	*CX=(AX1*AZ2)+(BX1*BZ2)+(CX1*CZ2) <<<<<<<<<<<<<

*CY = (AY1 * AZ2) + (BY1 * BZ2) + (CY1 * CZ2)
	CLR.L	D7		*Clear Accumulator
	MOVE.W	AY(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AY1*AZ2)
	MOVE.W	BY(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AY1*AZ2)+(BY1*BZ2)
	MOVE.W	CY(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AY1*AZ2)+(BY1*BZ2)+(CY1*CZ2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,CY(A0)	*CY=(AY1*AZ2)+(BY1*BZ2)+(CY1*CZ2) <<<<<<<<<<<<<

*CZ = (AZ1 * AZ2) + (BZ1 * BZ2) + (CZ1 * CZ2)
	CLR.L	D7		*Clear Accumulator
	MOVE.W	AZ(A1),D6
	MULS	D0,D6
	ADD.L	D6,D7		*D7=(AZ1*AZ2)
	MOVE.W	BZ(A1),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7=(AZ1*AZ2)+(BZ1*BZ2)
	MOVE.W	CZ(A1),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7=(AZ1*AZ2)+(BZ1*BZ2)+(CZ1*CZ2)

	ASL.L	#2,D7
	SWAP	D7		*Adjust binary point

	MOV.W	D7,CZ(A0)	*CZ=(AZ1*AZ2)+(BZ1*BZ2)+(CZ1*CZ2) <<<<<<<<<<<<<

	RTS	
*-------------------------------------------------------------------------------
	PAGE
* PRESUBTRACT (is currently naked anyway but will probably go in TMS320)
*
*	XP = AX * (X-XT) + BX * (Y-YT) + CX * (Z-ZT)
*	YP = AY * (X-XT) + BY * (Y-YT) + CY * (Z-ZT)
*	ZP = AZ * (X-XT) + BZ * (Y-YT) + CZ * (Z-ZT)
*
* Calling Routine supplies:
*	A0 points to Unit Vectors
*	A1 points to Object Position List
*	
* Uses:
*	D0 = X-XT
*	D1 = Y-YT
*	D2 = Z-ZT
*
*	D6 = Dn * D6, also temp
*	D7 is the Accumulator
*
* Takes about 132 uS/point
*
NPRESUB	
	MOVE.W	X(A1),D0
	SUB.W	XT(A0),D0	*D0 = X-XT
	MOVE.W	Y(A1),D1
	SUB.W	YT(A0),D1	*D1 = Y-YT
	MOVE.W	Z(A1),D2
	SUB.W	ZT(A0),D2	*D2 = Z-ZT

	CLR.L	D7		*clear accumulator
	MOVE.W	AX(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AX*(X-XT)

	MOVE.W	BX(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AX*(X-XT) + BX*(Y-YT)

	MOVE.W	CX(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AX*(X-XT) + BX*(Y-YT) + CX*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,XP		*XP = AX*(X-XT) + BX*(Y-YT) + CX*(Z-ZT) <<<<<<<
*------------------------------------------------------------------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AY(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AY*(X-XT)

	MOVE.W	BY(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AY*(X-XT) + BY*(Y-YT)

	MOVE.W	CY(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AY*(X-XT) + BY*(Y-YT) + CY*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,YP		*YP = AY*(X-XT) + BY*(Y-YT) + CY*(Z-ZT) <<<<<<<
*------------------------------------------------------------------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AZ(A0),D6
	MULS	D0,D6		
	ADD.L	D6,D7		*D7= AZ*(X-XT)

	MOVE.W	BZ(A0),D6
	MULS	D1,D6
	ADD.L	D6,D7		*D7= AZ*(X-XT) + BZ*(Y-YT)

	MOVE.W	CZ(A0),D6
	MULS	D2,D6
	ADD.L	D6,D7		*D7= AZ*(X-XT) + BZ*(Y-YT) + CZ*(Z-ZT)

	ASL.L	#2,D7		*Adjust binary point
	SWAP	D7

	MOVE.W	D7,ZP		*ZP = AZ*(X-XT) + BZ*(Y-YT) + CZ*(Z-ZT) <<<<<<<

	RTS
	PAGE
*-----------------------------------------------------------------------------
* TICS
*	ALGORITHM: By Greg Rivera and Jed Margolin 

*	This algorithm gets around the problem that when you are in the ship,
*	rotations of 0.636 degrees (the smallest magic angle in 16 bits) are
*	too coarse.
*------------------------------------------------------------------------------
* naked ROLL TIC
* A0 points to primary Unit Vectors (which also contain Tic angles)
* D0 CONTAINS DELTA ANGLE FOR ROLL, +/- 78 MAX
NT_ROLL:  
	ADD.B	R_ANGLE(A0),D0			*D0=NEW R_ANGLE
*Is the angle greater than or equal to 78?
	CMP.B	#78,D0
	BGE	NTR1	*yes
*Is the angle greater than or equal to 14?
	CMP.B	#14,D0
	BGE	NTR2	*yes
*Is the angle greater than -14?
	CMP.B	#-14,D0
	BGT	NTR3	*yes
*Is the angle greater than -78
	CMP.B	#-78,D0
	BGT	NTR4	*yes	
*If it gets this far, the angle is less than or equal to -78:
	ADD.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) + 78
	MOVE.B	D0,R_ANGLE(A0)
	MOVE.W	#-1424,D0	*SIN -4.986 degrees
	MOVE.W	#16322,D1	*COS -4.986 degrees
	BSR	NROLL		*Rotate the Primary Set by -4.986 degrees
	RTS	
	
NTR1 	SUB.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 78
	MOVE.B	D0,R_ANGLE(A0)
	MOVE.W	#1424,D0	*SIN 4.986 degrees
	MOVE.W	#16322,D1	*COS 4.986 degrees
	BSR	NROLL		*Rotate the Primary Set by 4.986 degrees
	RTS

NTR2 	SUB.B	#14,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 14
	MOVE.B	D0,R_ANGLE(A0)
	MOVE.W	#256,D0		*SIN 0.895 degrees
	MOVE.W	#16382,D1	*COS 0.895 degrees
	BSR	NROLL		*Rotate the Primary Set by 0.895 degrees
	RTS

NTR3 	MOVE.B	D0,R_ANGLE(A0)
	RTS	

NTR4 	ADD.B	#14,D0		*   *_ANGLE(A0) = *_ANGLE(A0) + 14
	MOVE.B	D0,R_ANGLE(A0)
	MOVE.W	#-256,D0	*SIN -0.895 degrees
	MOVE.W	#16382,D1	*COS -0.895 degrees
	BSR	NROLL		*Rotate the Primary Set by -0.895 degrees
	RTS
*------------------------------------------------------------------------------
	PAGE
* naked PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 78 MAX
NT_PTCH:  
	ADD.B	P_ANGLE(A0),D0	*D0=NEW P_ANGLE(A0)
*Is the angle greater than or equal to 78?
	CMP.B	#78,D0
	BGE	NTP1	*yes
*Is the angle greater than or equal to 14?
	CMP.B	#14,D0
	BGE	NTP2	*yes
*Is the angle greater than -14?
	CMP.B	#-14,D0
	BGT	NTP3	*yes
*Is the angle greater than -78
	CMP.B	#-78,D0
	BGT	NTP4	*yes	
*If it gets this far, the angle is less than or equal to -78:
	ADD.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) + 78
	MOVE.B	D0,P_ANGLE(A0)
	MOVE.W	#-1424,D0	*SIN -4.986 degrees
	MOVE.W	#16322,D1	*COS -4.986 degrees
	BSR	NPITCH		*Rotate the Primary Set by -4.986 degrees
	RTS	
	
NTP1 	SUB.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 78
	MOVE.B	D0,P_ANGLE(A0)
	MOVE.W	#1424,D0	*SIN 4.986 degrees
	MOVE.W	#16322,D1	*COS 4.986 degrees
	BSR	NPITCH		*Rotate the Primary Set by 4.986 degrees
	RTS

NTP2 	SUB.B	#14,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 14
	MOVE.B	D0,P_ANGLE(A0)
	MOVE.W	#256,D0		*SIN 0.895 degrees
	MOVE.W	#16382,D1	*COS 0.895 degrees
	BSR	NPITCH		*Rotate the Primary Set by 0.895 degrees
	RTS

NTP3 	MOVE.B	D0,P_ANGLE(A0)
	RTS	

NTP4 	ADD.B	#14,D0		*   *_ANGLE(A0) = *_ANGLE(A0) + 14
	MOVE.B	D0,P_ANGLE(A0)
	MOVE.W	#-256,D0	*SIN -0.895 degrees
	MOVE.W	#16382,D1	*COS -0.895 degrees
	BSR	NPITCH		*Rotate the Primary Set by -0.895 degrees
	RTS
*------------------------------------------------------------------------------
	PAGE
*YAW TIC:
* D0 CONTAINS DELTA ANGLE FOR YAW, +/- 78 MAX
NT_YAW  
	ADD.B	Y_ANGLE(A0),D0		*D0=NEW Y_ANGLE(A0)
*Is the angle greater than or equal to 78?
	CMP.B	#78,D0
	BGE	NTY1	*yes
*Is the angle greater than or equal to 14?
	CMP.B	#14,D0
	BGE	NTY2	*yes
*Is the angle greater than -14?
	CMP.B	#-14,D0
	BGT	NTY3	*yes
*Is the angle greater than -78
	CMP.B	#-78,D0
	BGT	NTY4	*yes	
*If it gets this far, the angle is less than or equal to -78:
	ADD.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) + 78
	MOVE.B	D0,Y_ANGLE(A0)
	MOVE.W	#-1424,D0	*SIN -4.986 degrees
	MOVE.W	#16322,D1	*COS -4.986 degrees
	BSR	NYAW		*Rotate the Primary Set by -4.986 degrees
	RTS	
	
NTY1 
	SUB.B	#78,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 78
	MOVE.B	D0,Y_ANGLE(A0)
	MOVE.W	#1424,D0	*SIN 4.986 degrees
	MOVE.W	#16322,D1	*COS 4.986 degrees
	BSR	NYAW		*Rotate the Primary Set by 4.986 degrees
	RTS

NTY2 	SUB.B	#14,D0		*  *_ANGLE(A0) = *_ANGLE(A0) - 14
	MOVE.B	D0,Y_ANGLE(A0)
	MOVE.W	#256,D0		*SIN 0.895 degrees
	MOVE.W	#16382,D1	*COS 0.895 degrees
	BSR	NYAW		*Rotate the Primary Set by 0.895 degrees
	RTS

NTY3 	MOVE.B	D0,Y_ANGLE(A0)
	RTS	

NTY4 	
	ADD.B	#14,D0		*   *_ANGLE(A0) = *_ANGLE(A0) + 14
	MOVE.B	D0,Y_ANGLE(A0)
	MOVE.W	#-256,D0	*SIN -0.895 degrees
	MOVE.W	#16382,D1	*COS -0.895 degrees
	BSR	NYAW		*Rotate the Primary Set by -0.895 degrees
	RTS
*------------------------------------------------------------------------------
	PAGE
* Naked (68010 only)
* Generate the Working Copy Unit Vectors
* Calling Routine supplies:
* 	A0 is the Working Set [UV2] 
* 	A1 is the Primary Set of Unit Vectors [UV1] 
* Uses lots of Registers
* Copies UV1 to UV2 and rotates by Roll, Pitch, and Yaw Tics.
* Takes about 620 uS, worst case, which is most of the time
* Seems to take about 440 uS
NWC_GEN:  
*COPY UNIT VECTORS FROM PRIMARY SET TO WORKING SET [ ex. UV1 TO UV2]

	MOVE.L	A0,A2
	MOVE.L	A1,A3
	MOVE.B	#$9,D0			*9 WORDS
NWC10	MOVE.W	(A3)+,(A2)+
	SUBQ.B	#1,D0
	BNE	NWC10	

*GENERATE THE WORKING COPY 
*ROLL WORKING COPY
NWC_ROLL 				
	MOVEA.L	#TICS,A3
	CLR.L	D0
	MOVE.B	R_ANGLE(A1),D0
	CMP.B	#0,D0
	BEQ	NWC_PTCH		* If angle is zero, no rotate
	BLT	NCX10			* Negative angle
	ASL.B	#2,D0			* Positive angle (2 words = 4 bytes)
	ADDA	D0,A3			* A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	MOVE.W	2(A3),D1		*COS

	BSR	NROLL			* ROLL working copy (in A0) by (SIN,COS)
	BRA	NWC_PTCH

NCX10	NEG.B	D0			* Negative angle (make it positive)
	ASL.B	#2,D0
	ADDA	D0,A3			*A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	NEG.W	D0			*-SIN	
	MOVE.W	2(A3),D1		*COS

	BSR	NROLL		* ROLL working copy (in A0) by (-SIN,COS)

*PITCH WORKING COPY
NWC_PTCH 				
	MOVEA.L	#TICS,A3
	CLR.L	D0
	MOVE.B	P_ANGLE(A1),D0
	CMP.B	#0,D0
	BEQ	NWC_YAW			* If angle is zero, no rotate
	BLT	NCX11			* Negative angle
	ASL.B	#2,D0			* Positive angle (2 words = 4 bytes)
	ADDA	D0,A3			* A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	MOVE.W	2(A3),D1		*COS

	BSR	NPITCH		*PITCH working copy (in A0) by (SIN,COS)
	BRA	NWC_YAW

NCX11	NEG.B	D0			* Negative angle (make it positive)
	ASL.B	#2,D0
	ADDA	D0,A3			*A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	NEG.W	D0			*-SIN	
	MOVE.W	2(A3),D1		*COS

	BSR	NPITCH		* PITCH working copy (in A0) by (-SIN,COS)

*YAW WORKING COPY
NWC_YAW 				
	MOVEA.L	#TICS,A3
	CLR.L	D0
	MOVE.B	Y_ANGLE(A1),D0
	CMP.B	#0,D0
	BEQ	NCX13			* If angle is zero, no rotate
	BLT	NCX12			* Negative angle
	ASL.B	#2,D0			* Positive angle (2 words = 4 bytes)
	ADDA	D0,A3			* A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	MOVE.W	2(A3),D1		*COS

	BSR	NYAW		*YAW working copy (in A0) by (SIN,COS)
	BRA	NCX13

NCX12	NEG.B	D0			* Negative angle (make it positive)
	ASL.B	#2,D0
	ADDA	D0,A3			*A3 = address of table entry

	MOVE.W	(A3),D0			*SIN
	NEG.W	D0			*-SIN	
	MOVE.W	2(A3),D1		*COS

	BSR	NYAW		* YAW working copy (in A0) by (-SIN,COS)

NCX13	RTS

* SINE COSINE FOR MAGIC TICS, 4000(16384.) IS UNITY
* TIC table is already defined                            

*===============================================================================
*===============================================================================
	ENDC			* End of Naked Math

MEND	END