* Started February, 1985
* Jed Margolin

	TTL 'TomCat'

	XREF INITUV,POST,POST2,ROLL,PITCH,YAW,CONCAT,PRESUB,TPROJ
	XREF TANK,CUBE,ROCKET,AIR,SAUCER,BUZZ,FLM,SQ,BOX,TSQ,HIND,CITY
	XREF VGHALT,CENTER,VGANLOC
	XREF D_CUBE,D_SQ,D_TANK,D_ROC,D_AIR,D_SAU,D_BUZZ,D_HIND,D_CITY
	XREF D2_CUBE,D2_SQ,D2_TANK,D2_ROC,D2_AIR,D2_SAU,D2_BUZZ,D2_HIND,D2_CITY
	XREF VGOVER,HUD,HEADING,ALTITUDE,AIRSPEED,VWTHRUST,HORIZ
	XREF VWHEX,FLY,FLY1,FLY2,EFLY2,FLY3,FLY4,FLY5,FLY6,VWBYTE,VWWORD,WC_GEN
	XREF HORIZ,RUNWAY,T_ROLL,T_PTCH,T_YAW
	XREF VJ_BKBOX,VJ_SITE,VJ_TITL,VJ_THRUST,VJ_HDN,VJ_ZOOM,VGIMAGE
	XREF VW_1D,VW_2D,VW_3D,VW_4D
	XREF TERR,VASI,LIGHTS,GUNS,PDOT
	XREF GRID,POTS,SW
	XREF RESUME,RT1,RT2,RT3,PCUBE,PTANK,PROC,PTERR
	XREF POST,DOWN320,C_320
	XREF M_CUBE,M_ROCKET,M_AIR,M_SAUCER,M_GRLINE,M_STARS,DOSTARS
	XREF S2CRASH,NPRESUB

	XREF TMSCODE,TMSEND
	XREF IM1LEN,MONSTER,PMESS

*	From Mike's program that takes the TMS320.LDA file and makes it into
*	TMS320.OL to be linked with the 68010 TomCat program. This is an
*	image file which the program downloads into the TMS320 RAM.
*	It begins at TMSCODE with a count of TMSEND (use DBF and download words)


	INCLUDE 'COMN.ASM'
	INCLUDE 'XDEFS.ASM'
	INCLUDE 'VECTORS.ASM'


	XDEF GO,GOLP,ATTN,IRQ,MPOTS,THRSW,SHOW_ROC,PDOT,SHOW_AIR,SHOW_SAU
	XDEF VGWAIT,VGWAIT2,ANUP,INIT,INITB,INIT320,GRAMCLR
	XDEF LIRQ,LIRQ1,LIRQ2,SHIP2S,GLINIT,GINIT
	XDEF ML_TX,ML_RCV,SL_RCV,SL_TX,SEND,RCV,TSEND1,TSEND2,TSEND3
	XDEF LCOM1,LCOM2,LCOM3,LCOM4,LCOM5,LCOM6,STBIN,TRB,MTBOUT
	XDEF DRDOTS,GL10B,TMSDNL,START,FUELMG

	SECTION PROGRAM

*For Development, if something screws up do an instruction to an illegal
*address to get the development system's attention.
*ATTN:	MOVE.W	#0,ATTN
*	BRA	ATTN
*
*For Standalone, Sit and Spin to let the Watchdog howl.
ATTN:	JMP	ATTN
*-------------------------------------------------------------------------------
	PAGE
	TTL 'MAIN'
* From Reset the program goes to 'START' (in Initialisation routines) and goes
* to the Player Menu ('PMESS' in MONTST Module). The actual game starts here.

GO:	BSR	GINIT		* Initialise for game

	BSR	GLINIT		* Initialise the Game_Link Interface

	MOVE.W #$2000,SR	* Enable Interrupts

*Main Loop
GOLP	
	BTST	#3,INPUTS	* SELF-TEST SWITCH
	BNE	GL0
	JMP	MONSTER

GL0	CLR.W	LED1ON	

* Decide which VG Buffer to use
	MOVEA.L	#VMEM,VG_PTR
	TST.B	BUFFER
	BEQ	GL1		*Buffer 1
	MOVEA.L VG_PTR,A0	
	MOVE.W	#$0EF00,(A0)	*Buffer 2 [JMPL 1E00] ($1E00/2=#0F00)
	ADD.L	#$1E00,VG_PTR

GL1	JSR	VGOVER		*Draw VG Overlay

	JSR	HUD		*Headup Display for Heading and Thrust 

	BSR 	MPOTS		*Mediate the Pots

	BSR	THRSW		*Read the Thrust Switches

*Generate the Working Copy Unit Vectors for Ship 1
	MOVEA.W	#UV2,A0
	MOVEA.W	#UV1,A1
	JSR 	WC_GEN		

*Fly Ship 1
	TST.W	CMODE		* 0 = computer assisted, 1 = manual
	BEQ	GL2
*	BTST	#OSW6,INPUTS+1					* SW 6 = Aero
*	BNE	GL2
	JSR	FLY3		* Manual Control, Simple Aerodynamics
	BRA	GL5

GL2	JSR 	FLY5		* Computer Assisted Control, Simple Aerodynamics

GL5	BTST	#OSW4,INPUTS+1				* SW 4 = Terrain Objects
	BNE	GL6
*Do Terrain Objects
	JSR	TERR

* Do the Horizon
GL6	JSR	HORIZ

	BTST	#OSW1,INPUTS+1				* SW 1 = Runway 
	BNE	GL7
* Do the Runway
	JSR	RUNWAY
* Do the VASI Lights
	JSR	VASI
* Do the Strobe Lights
	JSR	LIGHTS

GL7	
*	BTST	#3,INPUTS+1	* old SW 3 = Guns
*	BNE	GL8
* Do the Guns
	JSR	GUNS

	BSR	TRB		* Generate the Tracer Output Buffer

	TST.W	GLINK		* Are we linked
	BEQ	GL8		* no
*	BTST	#OSW8,INPUTS+1	* Are we Linked?
*	BNE	GL8		* no

 	LEA	TRIN,A1		* Display the Tracer Input Buffer
	MOVE.W	#$6780,STAT	* Color and Linear Brightness
	BSR	DRDOTS

GL8	BTST	#OSW2,INPUTS+1				* SW 2 = Grid
	BNE	GL9
* Do the Grid
	JSR 	GRID

GL9	BTST	#OSW3,INPUTS+1				* SW 3 = Stars
	BNE	GL10
	JSR	DOSTARS

* Do Ship 2
GL10	BSR	SHIP2S

GL10B	MOVE.L	VG_PTR,A0	
	BRA	GL12
*==============================
	MOVE.W	#$7200,(A0)+
	MOVE.W	#$6740,(A0)+
	MOVE.W	#$100,(A0)+
	MOVE.W	#$0,(A0)+
	MOVE.W	FX+UV4,D0	*FX + UV4	Temp for reading LINK
	JSR	VW_4D
	MOVE.W	#$8040,(A0)+

	MOVE.W	#$0D0,(A0)+
	MOVE.W	#$0,(A0)+
	MOVE.W	LNKERRS,D0	* LINK ERRORS	
	JSR	VW_4D
	MOVE.W	#$8040,(A0)+

	BRA	GL12

	MOVE.W	#$040,(A0)+
	MOVE.W	#$0,(A0)+
	TST.B	GLOW		*HITS
	BEQ	GL11
	MOVE.W	#$6480,(A0)+	*Red

GL11	CLR.W	D0
	MOVE.B	GLOW,D0		*HITS
	
	MOVE.W	FZ+UV2,D0	*FZ + UV2
	JSR	VW_4D
	MOVE.W	#$8040,(A0)+

GL12	MOVE.W	#$2020,(A0)+	*VG Halt Instruction
	MOVE.L	A0,VG_PTR

	EOR.B	#1,BUFFER	*This Buffer is done

	CLR.W	LED1OFF	
*==============================
	CLR.W	LED2ON
* Game Link

	TST.W	GLINK		* Are we linked
	BEQ	WLP2		* no
*	BTST	#OSW8,INPUTS+1	* Are we Linked?
*	BNE	WLP2		* no

	BTST	#OSW7,INPUTS+1	* Are we the Slave?
	BEQ	WLP2		* yes

	BSR	SEND		* Send Master UV2
	BSR	RCV		* Receive Slave UV4
	BSR	MTBOUT		* Send Master Tracer Buffer
	BSR	STBIN		* Receive Slave Tracer Buffer
	CLR.W	LED2OFF
*==============================
*For now, wait for transition from IRQFRAME 4 to IRQFRAME 0
WLP2	CMP.B	#4,IRQFRAME	* Wait for IRQ frame 3
	BNE	WLP2
WTLP	TST.B	IRQFRAME	* Wait for IRQ frame 0
	BNE	WTLP

	BSR 	VGWAIT		* Wait for VG to be done [should be done]	

	CLR.W	VGGO		* Start VG	

	CLR.W	WDCLR		* Kick the Watchdog 

	BSR	FUELMG		* Fuel Management

* If the Fuel is zero and we are on the ground -> Game Over.
	TST.L	FUEL
	BNE	GOLP		* Fuel ok

	MOVE.W	UV2+ZT,D0
	CMP.W	#$42,D0
	BPL	GOLP		* No fuel but hasn't hit the ground yet
	
	JMP 	START		* Restart with Player Menu	
*===============================================================================
	PAGE
SHIP2S
* Ship 2 Routines 

	TST.W	GLINK		* Are we linked
	BEQ	S2R_NL		* no
*	BTST	#OSW8,INPUTS+1			* SW 8 = To Link or not to Link
*	BNE	S2R_NL				* no

* Linked!
* (UV4 contains Unit Vectors + XT,YT,ZT for Ship 2) [provided by the link]
	BSR	SHOW_ROC	
	RTS

* Not Linked
*Generate the Working Copy Unit Vectors for Ship 2
S2R_NL:	
	MOVEA.W	#UV4,A0
	MOVEA.W	#UV3,A1
	JSR 	WC_GEN		

*Fly Ship 2
	MOVE.W	#$2000,THRUST(A0)

	BTST	#OSW5,INPUTS+1				* SW 5 = Ship 2 Controls
	BEQ	S2NL2
	MOVE.W	#$400,ZT(A0)
	JSR	EFLY2			* FLY SHIP 2 STRAIGHT AHEAD
	BRA	S2NL3

S2NL2	JSR 	FLY6		* FLY SHIP 2 WITH CONTROLS

*Show Ship 2
S2NL3	MOVEA.W	#UV4,A0		*UV4 is the Working Set
	TST.B	S2CFLAG		* SHIP 2 CRASH FLAG
	BEQ	SHOW_ROC	* (no crash) 	[BSR SHOW_ROC;RTS]
	JSR	S2CRASH		* (crash)
	RTS
*===============================================================================
	PAGE

* Draw a list of dots
* A1 = Input List
* First word contains # of words. First word = '1' for no dots 

* Call it with:
* 	LEA	TRIN,A1
*	MOVE.W	#$6780,STAT	* Color and Linear Brightness
*	BSR	DRDOTS


DRDOTS:
	MOVE.W	(A1)+,D3	* D3 = # of input words (points * 3 + 1)
	BEQ	DRD6		* Nothing to draw at all, not even initialised

	SUBQ.W	#1,D3		* D3 = # points * 3
	BEQ	DRD6		* Initialised but still noting to draw

	CLR.W	D4		* D4 = # of output points
* Presubtract the list
* Output XP, YP, ZP

	LEA	UV2,A0
	LEA	PTBL,A5
*=====================================
* Calling Routine supplies:
*	A0 points to Unit Vectors
*	A1 points to Object Position List

* NAKED PRESUBTRACT 
*
*	XP = AX * (X-XT) + BX * (Y-YT) + CX * (Z-ZT)
*	YP = AY * (X-XT) + BY * (Y-YT) + CY * (Z-ZT)
*	ZP = AZ * (X-XT) + BZ * (Y-YT) + CZ * (Z-ZT)
*
* Calling Routine supplies:
*	A0 points to Unit Vectors
*	A1 points to Object Position List
*	
* Uses:
*	D0 = X-XT
*	D1 = Y-YT
*	D2 = Z-ZT
*
*	D6 = Dn * D6, also temp
*	D7 is the Accumulator
*=====================================

DRD1	JSR	NPRESUB		* look at it (Output XP, YP, ZP)

* Light is at XP,YP,ZP
* Check to see if it is visible.
	MOVE.W	XP,D0
	CMP.W	#$80,D0
	BLE	DRD4

	MOVE.W	YP,D1
	EXT.L	D1
	BPL	DRD2
	NEG.W	D1
DRD2	CMP.W	D0,D1
	BGT	DRD4

* ABS(YP) .LE. XP
	MOVE.W	ZP,D2
	EXT.L	D2
	BPL	DRD3
	NEG.W	D2
DRD3	CMP.W	D0,D2
	BGT	DRD4

* ABS(ZP) .LE XP

*Project the point at (XP,YP,ZP)
* Uses D0,D1,D2
	MOVE.W 	XP,D0		* D0 = XP 

	CLR.L	D1
	MOVE.W	ZP,D1
	SWAP	D1
	ASR.L	#2,D1
	DIVS	D0,D1		* D1 = ZP/XP	
	ASR.W	#5,D1		* D1 = ZP/XP (scaled)	

	CLR.L	D2
	MOVE.W	YP,D2
	SWAP	D2
	ASR.L	#2,D2
	DIVS	D0,D2		* D2 = YP/XP
	ASR.W	#5,D2		* D2 = YP/XP (scaled)

* Put it in PTBL
	MOVE.W	D2,(A5)+	* Screen X	
	MOVE.W	D1,(A5)+	* Screen Y

	ADDQ.W	#1,D4		* Add to Point Count

DRD4	ADDQ.L	#6,A1		* Increment pointer to TRIN

* Are we done?
	SUB.W	#3,D3
	BNE	DRD1		* Do it Again

* Now that we are here, we have a list of projected points at PTBL, ready
* to be drawn.
* D4 = # points

	TST.W	D4		* Are there in fact any to be drawn?
	BEQ	DRD6		* (nope)	

	MOVE.L	VG_PTR,A0		* Initialise stuff for VG
	CLR.W	CURRX
	CLR.W	CURRY
	LEA	PTBL,A1

* Format and add to VG Buffer
	MOVE.W	#$7200,(A0)+
	MOVE.W	STAT,(A0)+	* STAT Instruction
	
DRD5
	MOVE.W	Y(A1),D1
	SUB.W	CURRY,D1
	AND.W	#$1FFF,D1	*dy
	MOVE.W	D1,(A0)+

	MOVE.W	X(A1),D1
	SUB.W	CURRX,D1
	AND.W	#$1FFF,D1	*dx
	MOVE.W	D1,(A0)+

	MOVE.L	#$000006000,(A0)+	*dot

	MOVE.W	X(A1),CURRX
	MOVE.W	Y(A1),CURRY

	ADDQ.L	#4,A1			* Increment by two words

	SUB.W	#1,D4
	BNE	DRD5			* More

	MOVE.W	#$8040,(A0)+		* center
	MOVE.L	A0,VG_PTR

DRD6	RTS
*===============================================================================
*===============================================================================
	PAGE
*-------------------------------------------------------------------------------
	PAGE
* Show Ship 2 as a Rocket
SHOW_ROC:	

* Find the Object's center:
*	If it is not visible set D0=FF;
*	If it is visible but only as a dot, draw the dot and set D0=FF; 
*	If it is visible, perform the concatenation and set D0=0
	BSR	OBJSUB		
		
	BEQ	SROC2
	RTS

*Transform the Rocket and Draw it
SROC2	MOVEA.W	#CCUV,A0	*Post Add Transform CCUV to Point Table
	LEA.L	ROCKET,A1	*Ship 2 is a Rocket
	MOVEA.W	#PTBL,A2	*Put Projected points in the Point Table

* This is where the rocket is in the 320 RAM
	MOVE.W	#M_ROCKET,m_tptr

	MOVE.L	#25,D5		*There are 25 points in the Rocket

	JSR	POST		* 
	JSR	D2_ROC		* Draw the Rocket

	RTS

* OBJECT SUBROUTINE
OBJSUB:
* Find Ship 2 center point
	MOVEA.W	#UV2,A0
	MOVEA.W	#UV4+XT,A1	* A1 points to XT,YT,ZT in UV4

	JSR	PRESUB		* Output in XP, YP, ZP 

* Object center point is at XP,YP,ZP
* Check to see if the object is visible.
	MOVE.W	XP,D0
	CMP.W	#$80,D0
	BGE	SR2	
	MOVE.W	#$0FF,D0
	RTS
*(XP .GE. $100)
SR2	MOVE.W	YP,D1
	EXT.L	D1
	BPL	SR3
	NEG.W	D1
SR3	CMP.W	D0,D1
	BLE	SR4
	RTS
*ABS(YP) .LE. XP
SR4	MOVE.W	ZP,D2
	EXT.L	D2
	BPL	SR5
	NEG.W	D2
SR5	CMP.W	D0,D2
	BLE	SR5B
	RTS
*ABS(ZP) .LE XP

* Ship 2 will be visible
SR5B	MOVE.B #$40,D4		* Intensity cuing
	MOVE.B	XP,D3		
	SUB.B	D3,D4
	MOVE.B	D4,BRITE

* But if it is greater than $3000 away, just draw a dot 
	CMP.W	#$3000,XP
	BLE	SR6
* Project and draw a Dot at its Center Point
	MOVE.W	#$6780,STAT	*White, Full Brite
	JSR	PDOT
	MOVE.W	#$0FF,D0	* THIS MEANS THAT ONLY A DOT WAS DRAWN 
	RTS

* Draw the entire ship
* Put XP,YP,ZP into XT,YT,ZT in CONCAT 
SR6	MOVEA.W	#CCUV,A0	*Translate Ship
	MOVE.W	XP,XT(A0)	
	MOVE.W	YP,YT(A0)	
	MOVE.W	ZP,ZT(A0)	

* Form Concatenation Matrix for looking at Ship 2
	MOVEA.W	#CCUV,A0	*Concatenate Unit Vectors
	MOVEA.W	#UV2,A1		*UV2 is the working copy (Ship)
	MOVEA.W	#UV4,A2		*UV3 is Ship 2 Unit Vectors (working set)
	JSR	CONCAT		*Ship in A1 looks at Ship in A2

	CLR.W	D0		* THIS MEANS DRAW THE OBJECT
	RTS

*-------------------------------------------------------------------------------
	PAGE
* Show Ship 2 as an Airplane
SHOW_AIR:	

* Find the Object's center:
*	If it is not visible set D0=FF;
*	If it is visible but only as a dot, draw the dot and set D0=FF; 
*	If it is visible, perform the concatenation and set D0=0
	BSR	OBJSUB		
		
	BEQ	SAIR2
	RTS

*Transform the Rocket and Draw it
SAIR2	MOVEA.W	#CCUV,A0	*Post Add Transform CCUV to Point Table
	LEA.L	AIR,A1		*Ship 2 is a Rocket
	MOVEA.W	#PTBL,A2	*Put Projected points in the Point Table

* This is where the rocket is in the 320 RAM
	MOVE.W	#M_AIR,m_tptr

	MOVE.L	#24,D5		*There are 24 points in the Airplane

	JSR	POST		* 
	JSR	D2_AIR		* Draw the Airplane

	RTS
*-------------------------------------------------------------------------------
	PAGE
* Show Ship 2 as a Flying Saucer
SHOW_SAU:	

* Find the Object's center:
*	If it is not visible set D0=FF;
*	If it is visible but only as a dot, draw the dot and set D0=FF; 
*	If it is visible, perform the concatenation and set D0=0
	BSR	OBJSUB		
		
	BEQ	SAU2
	RTS

*Transform the Saucer and Draw it
SAU2	MOVEA.W	#CCUV,A0	*Post Add Transform CCUV to Point Table
	LEA.L	SAUCER,A1	*Ship 2 is a Rocket
	MOVEA.W	#PTBL,A2	*Put Projected points in the Point Table

* This is where the Saucer is in the 320 RAM
	MOVE.W	#M_SAUCER,m_tptr

	MOVE.L	#17,D5		*There are 17 points in the Saucer

	JSR	POST		* 
	JSR	D2_SAU		* Draw the Saucer

	RTS
*-------------------------------------------------------------------------------
	TTL 'TomCat - Initialisation'
	PAGE
*Main Program Initialization
START:
* Neutralise Link Mode
	CLR.W	TXBUFFH		
	CLR.W	LNKMODEL

* Clear RAM (But not stack area)
	MOVEA.W	#RAM,A0
	MOVE.W	#1024,D0	*Clear RAM: 1024. words = 2048 bytes 
PINIT1	CLR.W	(A0)+
	DBF	D0,PINIT1
*===============================================================================
* Do the menu
	JMP	PMESS		* Do the menu
*===============================================================================
* Clear Game RAM  (Leave first 32 bytes alone)
LALONE	EQU	32
GRAMCLR:
	MOVEA.W	#(RAM+LALONE),A0
	MOVE.W	#(1024-LALONE),D0
GRAMC1	CLR.W	(A0)+
	DBF	D0,GRAMC1
	RTS

* Used by some test programs [change this]
*Clear RAM, Initialise Unit Vectors, Reset VG, and Upload Alpha-Numerics 
INIT:	MOVEA.W	#RAM,A0
	MOVE.L	#1024,D0	*Clear RAM: 1024. words = 2048 bytes 

INIT1	CLR.W	(A0)+
	SUBQ.L	#1,D0
	BNE	INIT1

INITB	MOVEA.W	#UV1,A0		*Initialise Unit Vectors for Ship 1 (Primary)
	JSR	INITUV

	MOVEA.W	#UV2,A0		*Initialise Unit Vectors for Ship 1 (Working)
	JSR	INITUV
	MOVE.W	#$20,ZT(A0)

	MOVEA.W	#UV3,A0		*Initialise Unit Vectors for Ship 2 (Primary)
	JSR	INITUV

	MOVEA.W	#UV4,A0		*Initialise Unit Vectors for Ship 2 (Working)
	JSR	INITUV
	
	CLR.W	VGRES		*Reset Vector Generator	
	CLR.W	SNDRESL		*Reset Sound System
	CLR.W	SNDRESH		

	BSR	ANUP		*Upload Alphanumerics

	RTS
*-------------------------------------------------------------------------------
* Initialize the TMS320
INIT320:
	CLR.W	MRESL		*TMS320 Reset Low
	CLR.W	MRESH		*	Reset High

* 320 is now spinning, waiting for BIO to go high
	MOVE.W	#$100,m_xmin	* For clipping 
* Set up Branch Instruction
	MOVE.W	#$0F900,M_PROG
	MOVE.W	#M_INIT,M_PROG+2

*Start 320
	TST.W	MBIOH

* Wait for it to be done
W320	BTST	#1,IN1
	BNE	W320
	RTS			* all done
*-------------------------------------------------------------------------------
* GAME initialisation
GINIT:	
	CLR.W	VGRES		* Reset Vector Generator	

	CLR.W	SNDRESL		* Reset Sound System
	CLR.W	SNDRESH		

	CLR.W	MRESL		* Reset TMS-320
	CLR.W	MRESH

	BSR	GRAMCLR		* Clear RAM for Game

	MOVEA.W	#UV1,A0		* Initialise Unit Vectors for Ship 1 (Primary)
	JSR	INITUV

	MOVEA.W	#UV2,A0		* Initialise Unit Vectors for Ship 1 (Working)
	JSR	INITUV
	MOVE.W	#$20,ZT(A0)

	MOVEA.W	#UV3,A0		* Initialise Unit Vectors for Ship 2 (Primary)
	JSR	INITUV

	MOVEA.W	#UV4,A0		* Initialise Unit Vectors for Ship 2 (Working)
	JSR	INITUV
	
	MOVE.L	#500000,FUEL		* Initialise Fuel

	BSR	ANUP		* Upload Alphanumerics

	BSR	TMSDNL		* Download TMS320 program image

	BSR	INIT320		* Initialise the TMS320

	JSR	DOWN320		* Download the objects into 320 RAM
	
* Are we linked?
	TST.W	GLINK		
	BNE	GINIT1		

* No: Neutralise Link Mode
	CLR.W	TXBUFFH		
	CLR.W	LNKMODEL
	RTS			* All done

* yes: Initialise the Game_Link Interface
GINIT1	BSR	GLINIT		
	RTS
*-------------------------------------------------------------------------------
	PAGE
* Download TNS320 program image to TMS320 RAM
TMSOFS	SET	$100			* Program starts with address offset
TMSDNL:	
	MOVEA.L	#TMSCODE+TMSOFS,A0		* TMS320 Program Image
	MOVEA.L	#M_320+TMSOFS,A1		* TMS320 RAM
	MOVE.L	#TMSEND-(TMSOFS/2),D0		* Number of Words	
TMSDLP	MOVE.W	(A0)+,(A1)+
	DBF	D0,TMSDLP
	RTS		

* Download Alphanumerics VG Image (VGIMAGE) to VG Alphanumerics Address (VGANLOC)
ANUP:	
	MOVEA.L	#VGIMAGE,A0		* VGIMAGE  
	MOVEA.L	#VMEM+VGANLOC,A1	* VMEM+VGANLOC
	MOVE.W	#IM1LEN,D0		* LENGTH OF VG ALPHANUMERICS IMAGE (.W)
ANLP	MOVE.W	(A0)+,(A1)+
	DBF	D0,ANLP
	RTS		

* Wait for VGHALT
VGWAIT:	BTST	#$00,INPUTS	
	BEQ	VGWAIT
	RTS

* Wait for VGHALT but do VG reads while waiting (to test the memory contention
* circuit).
VGWAIT2:	
	MOVE.W	VMEM,D0
	BTST	#$00,INPUTS	
	BEQ	VGWAIT2
	RTS

* Mediate the Pots
MPOTS: 
	MOVE.B	RPOT0,D0
	BSR	PSUB
	MOVE.B	D0,POT0

	MOVE.B	RPOT1,D0
	BSR	PSUB
	MOVE.B	D0,POT1

	MOVE.B	RPOT2,D0
	BSR	PSUB
	MOVE.B	D0,POT2

	MOVE.B	RPOT3,D0
	BSR	PSUB
	MOVE.B	D0,POT3

	RTS
*---------------------------------------------------
* POT SUBROUTINE, CENTER, SQUARE, AND LIMIT THE POT
* INPUT IS D0
* OUTPUT IS DO

PSUB:	SUB.B	#$80,D0		* Pot is centered, 80 to 7F
	EXT.W	D0
	MOVE.W	D0,D1		* SAVE IT FOR THE SIGN
	MULS	D0,D0		* D1 = POT SQUARED, 3F01 MAX
	ASR.W	#8,D0		* SCALE, MAX IS $3F 
	ASR.W	#2,D0
	CMP.W	#$40,D0		* LIMIT IT TO $40
	BLE	PSUB1
	MOVE.W 	#$40,D0

PSUB1	TST.W	D1		* RESTORE THE SIGN
	BPL	PSUB2
	NEG.W	D0

PSUB2	RTS


* Read the Thrust control switches, ramp thrust as required
THRSW:	MOVEA.W	#UV2,A0			* Do it for Ship 1
	MOVE.W	THRUST(A0),D1

	TST.L	FUEL
	BEQ	THR4			* If no Fuel, Shut it down

THR1	MOVE.B	INPUTS,D0		* D0 CONTAINS SWITCH INPUTS
	BTST	#7,D0
	BNE 	THR2
*Left Thumb (Ramp down)
THR1A	SUB.W	#$60,D1
*Thrust cannot be less than $0
	BLT	THR2			* patch to NOP to allow negative thrust
	MOVE.W	D1,THRUST(A0)
	RTS

THR2	BTST	#6,D0
	BNE 	THR3
*Right Thumb (Ramp up)
	ADD.W	#$60,D1	
*Thrust cannot be greater than $4000
	CMP.W	#$4000,D1
	BGT	THR3
	MOVE.W	D1,THRUST(A0)

THR3	RTS

THR4	SUB.W	#$80,D1
	BPL	THR5
	CLR.W	THRUST(A0)
	RTS
THR5	MOVE.W	D1,THRUST(A0)
	RTS

*-------------------------------------------------------------------------------
* Fuel Management:
*	1. Fuel is decremented to serve as a game timer.
*	2. Fuel is also decremented as a function of Thrust.
*	3. The After-Burner is a real fuel hog.



FUELMG
	MOVE.L	FUEL,D0
	SUB.L	#$10,D0			* Decrement fuel

	MOVE.B	UV2+THRUST,D1		* Max Thrust is $40 ($4000 for word)
	LSR.B	#2,D1
	EXT.W	D1
	EXT.L	D1				* Max Fuel burden is $10

	SUB.L	D1,D0
	BMI	FMAG1
	MOVE.L	D0,FUEL
	RTS
	
FMAG1	CLR.L	FUEL
	RTS
		
	TTL 'TomCat - IRQ'
	PAGE
* IRQ: Read the pots, Clear the IRQ Flag and Return
IRQ:	

* Save Registers on the Stack
	MOVEM.L	D0/D1/A0/A1,-(A7)	

* Pots - Read the last one
	CLR.L	D0
	MOVE.B	IRQFRAME,D0
	MOVEA.W	#RPOT0,A0		*Raw Pot Value		
	ADDA.L	D0,A0
	MOVE.B	ADCREAD+1,(A0)

* Increment IRQ Frame number  ( There will be 5 IRQs per frame)
	ADDQ.B	#1,D0
	CMP.B	#$05,D0
	BNE	IRQ2
	CLR.W	D0
*	AND.B	#$03,D0
IRQ2	MOVE.B	D0,IRQFRAME

*Pots - (Start the next one)
	MOVE.B	D0,ADCON+1		*Channel number
	OR.B	#$08,D0
	MOVE.B	D0,ADCON+1		*ALE High
	AND.B	#$07,D0
	MOVE.B	D0,ADCON+1		*ALE Low
	OR.B	#$08,D0
	MOVE.B	D0,ADCON+1		*ALE High
	AND.B	#$07,D0
	MOVE.B	D0,ADCON+1		*ALE Low

* Restore Registers from the Stack
	MOVEM.L	(A7)+,D0/D1/A0/A1	

	CLR.W	IRQCLR
	RTE	
*-------------------------------------------------------------------------------
	TTL 'TomCat - Game Link'
	PAGE

* Link IRQ 
LIRQ:
	MOVEM.L	D0/D1/A0/A1,-(A7)	* Save Registers on the Stack

	TST.W	GLINK			* Are we linked?
	BNE	LIRQ1			* yes
*	BTST	#OSW8,INPUTS+1		* Are we Linked?
*	BEQ	LIRQ1			* yes

	JMP	ATTN			* no (This is a fatal error for now)

LIRQ1	BTST	#OSW7,INPUTS+1		* Are we the Slave?
	BEQ	LIRQ2
	JMP	ATTN			* (Only the Slave should get Link IRQs)

LIRQ2	BTST	#5,IN1			* Is this a command?
	BNE	LIRQ3

	ADDQ.W	#1,LNKERRS		* LOG ERRORS

	MOVEM.L	(A7)+,D0/D1/A0/A1	* Restore Registers from the Stack

	CLR.W	ACKH			* Clear LINKFLAG
	CLR.W	ACKL

	RTE
	
* We have received a valid Command Link IRQ. Read and Acknowledge it.
LIRQ3	MOVE.W	LNKRD,D1
	CLR.W	ACKH
	CLR.W	ACKL

	CMP.W	#$8000,D1	* Command: Master Sends Unit Vectors to Slave
	BEQ	LCOM1

	CMP.W	#$8001,D1	* Command: Slave Sends Unit Vectors to Master
	BEQ	LCOM2

	CMP.W	#$8002,D1	* Command: Just Read and Acknowledge it.
	BEQ	LCOM3
	
	CMP.W	#$8003,D1	* Command: Acknowledge and Echo it.
	BEQ	LCOM4

	CMP.W	#$8004,D1	* Command: Master sends Tracer List to Slave
	BEQ	LCOM5

	CMP.W	#$8005,D1	* Command: Slave sends Tracer List to Master
	BEQ	LCOM6

	ADDQ.W	#1,LNKERRS	* LOG ERRORS

	MOVEM.L	(A7)+,D0/D1/A0/A1	* Restore Registers from the Stack
	RTE

*	JMP	ATTN		* Shouldn't get here
*===============================================================================
	PAGE
* Master sends the Coefficients from Ship 1, (12 coefficients at UV2) 
* 
SEND:	CLR.W	TXBUFFL			* Turn on TX Buffer

	MOVE.W	#$8000,LNKWR+2		* Command

SEND1	BTST	#7,IN1			* Wait for Acknowledge
	BEQ	SEND1			

	MOVE.W	#12,D0			* Master sends a Block of Data
	LEA	UV2,A1
	BSR	ML_TX

	CLR.W	TXBUFFH			* Turn off TX Buffer
	RTS
*======================
* Master transmits a Block of Data @A1, # words = D0 
ML_TX:
	MOVE.W	(A1)+,LNKWR

MLTX1	BTST	#7,IN1			* Wait for Acknowledge
	BEQ	MLTX1			*	

	SUBQ.W	#1,D0
	BNE	ML_TX			* Do it until we are done

	RTS
*===============================================================================
* Slave receives 12 coefficients into UV4
LCOM1:	BTST	#6,IN1		* Wait for LNKFLAG
	BNE	LCOM1		* Wait for first data word

	MOVE.W	#12,D0
	LEA	UV4,A1
	BSR	SL_RCV

	MOVEM.L	(A7)+,D0/D1/A0/A1	* Restore Registers from the Stack
	RTE
*======================
* Slave receives a Block of Data @A1, D0 = # of words 
SL_RCV:	
	BTST	#6,IN1			* PC3 = Master's LNKFLAG=0 active
	BNE	SL_RCV

	MOVE.W	LNKRD,(A1)+		* Get the Data
	CLR.W	ACKH			* Acknowledge
	CLR.W	ACKL

	SUBQ.W	#1,D0
	BNE	SL_RCV

	RTS
*===============================================================================
	PAGE
* Master receives the Coefficients from Ship 2 (12 coefficients at UV4)
RCV:	
	CLR.W	TXBUFFL			* Turn on TX Buffer
	MOVE.W	#$8001,LNKWR+2		* Command

RCV1	BTST	#7,IN1			* Wait for Acknowledge
	BEQ	RCV1			

	CLR.W	TXBUFFH			* Turn off TX Buffer

	MOVE.W	#12,D0			* Master receives a Block of Data
	LEA	UV4,A1
	BSR	ML_RCV
	RTS
*======================
* Master receives a Block of Data @A1, #words = D0
ML_RCV:
	CLR.W	LNKWR			* Do a dummy write to set the Link Flag

MLRCV1  BTST	#7,IN1			* Wait for Slave's ACK
	BEQ	MLRCV1

	MOVE.W	LNKRD,(A1)+		* Read it

	SUBQ.W	#1,D0
	BNE	ML_RCV			* Do it until we are done

	CLR.W	LNKWR		* Do a dummy write to set the last Link Flag
	RTS
*===============================================================================
* Slave send 12 coefficients from UV2
LCOM2:	BTST	#6,IN1		* Wait for LNKFLAG
	BNE	LCOM2		* Wait for next word

	MOVE.W	#12,D0
	LEA	UV2,A1
	BSR	SL_TX

	MOVEM.L	(A7)+,D0/D1/A0/A1	* Restore Registers from the Stack
	RTE
*======================
* Slave transmits a Block of Data @A1, D0 = # of words 
SL_TX:
	CLR.W	TXBUFFL			* Turn on the TX Buffer

SLTX1	BTST	#6,IN1			* PC3 = Master's LNKFLAG=0 active
	BNE	SLTX1		
	
	MOVE.W	(A1)+,LNKWR		* Send the Data	
	CLR.W	ACKH			* Send ACK
	CLR.W	ACKL
	
	SUBQ.W	#1,D0
	BNE	SLTX1

SLTX2	BTST	#6,IN1
	BNE	SLTX2			* Wait for last LNKFLAG
	CLR.W	ACKH			* Acknowledge
	CLR.W	ACKL
	
	CLR.W	TXBUFFH			* Now it is ok to Turn off the TX Buffer
	RTS				* We are done
*===============================================================================
	PAGE
* Test the LINK: Master sends data once per frame.
TSEND3:
	CLR.W	TXBUFFL			* Turn on TX Buffer

	MOVE.W	#$8003,LNKWR+2		* Command

TS3A	BTST	#7,IN1			* Wait for Acknowledge
	BEQ	TS3A			

	MOVE.W	FX+UV4,LNKWR		* Send data

TS3B	BTST	#7,IN1
	BEQ	TS3B			* Wait for Acknowledge

	CLR.W	TXBUFFH			* Turn off TX Buffer

	CLR.W	LNKWR			* Dummy Write to assert LINKFLAG

TS3C	BTST	#7,IN1
	BEQ	TS3C			* Wait for Acknowledge (Data Ready)

	MOVE.W	LNKRD,D0
	
	CMP.W	FX+UV4,D0		* Is it what we sent?
	BEQ	TS3D
	ADDQ.W	#1,LNKERRS		* Log Errors

TS3D	ADDQ.W	#1,FX+UV4		* Increment Test Data
	RTS
*===============================================================================
* Slave reads link and Acknowledges it
LCOM3:	BTST	#6,IN1		* Wait for LNKFLAG
	BNE	LCOM3		* 

	MOVE.W	LNKRD,FX+UV4	* Temp for reading LINKRD
	CLR.W	ACKH		* Acknowledge
	CLR.W	ACKL

	MOVEM.L	(A7)+,D0/D1/A0/A1	* Restore Registers from the Stack
	RTE
*===============================================================================
	PAGE
* Test the LINK: Master sends data continuously.
TSEND1:
	BSR	GLINIT			* Initialise the Game_Link Interface

	CLR.W	TXBUFFL			* Turn on TX Buffer

	MOVE.W	#$8002,LNKWR+2		* Command

TS1A	BTST	#7,IN1			* Wait for Acknowledge
	BEQ	TS1A			

	MOVE.W	#$5555,LNKWR

TS1B	BTST	#7,IN1
	BEQ	TS1B			* Wait for ACK

	CLR.W	TXBUFFH			* Turn off TX Buffer
	BRA	TSEND1
*=========================================
* Test the LINK: Send data continuously.
TSEND2:
	BSR	GLINIT			* Initialise the Game_Link Interface

	CLR.W	TXBUFFL			* Turn on TX Buffer

	MOVE.W	#$8003,LNKWR+2		* Command

TS2A	BTST	#7,IN1			* Wait for Acknowledge
	BEQ	TS2A			

	MOVE.W	FX+UV4,LNKWR		* Send data

TS2B	BTST	#7,IN1
	BEQ	TS2B			* Wait for Acknowledge

	CLR.W	TXBUFFH			* Turn off TX Buffer

	CLR.W	LNKWR			* Dummy Write to assert LINKFLAG

TS2C	BTST	#7,IN1
	BEQ	TS2C			* Wait for Acknowledge (Data Ready)

	MOVE.W	LNKRD,D0
	
	CMP.W	FX+UV4,D0
	BEQ	TS2D
	ADDQ.W	#1,LNKERRS		* Log Errors

TS2D	ADDQ.W	#1,FX+UV4		* Increment Test Data
	BRA	TSEND2
*===============================================================================
	PAGE
* Read It and Echo It
LCOM4:	BTST	#6,IN1		* Wait for LNKFLAG
	BNE	LCOM4		* 

	MOVE.W	LNKRD,FX+UV4	* Temp for reading LINKRD
	CLR.W	ACKH		* Acknowledge
	CLR.W	ACKL

LC4A	BTST	#6,IN1
	BNE	LC4A		* Wait for next LNKFLAG

* Master is ready to receive
	CLR.W	TXBUFFL		* Turn on TX Buffer
	
	MOVE.W	FX+UV4,LNKWR	* Echo it

	CLR.W	ACKH		* Tell Master there is data waiting
	CLR.W	ACKL

LC4B	BTST	#6,IN1
	BNE	LC4B		* Wait for last LNKFLAG

	CLR.W	TXBUFFH		* Turn off TX Buffer	

	CLR.W	ACKH		* Acknowledge
	CLR.W	ACKL

	MOVEM.L	(A7)+,D0/D1/A0/A1	* Restore Registers from the Stack
	RTE
*===============================================================================
	PAGE
* Master sends the Tracer Out Buffer: 
 
MTBOUT	LEA	TROUT,A0

	MOVE.W	(A0),D1			* D1 = # of words
	BNE	MTB2			* If empty, send one '0'
	
	ADDQ.W	#1,D1		* This will make it send one '0' (just in case)


MTB2	CLR.W	TXBUFFL			* Turn on TX Buffer

	MOVE.W	#$8004,LNKWR+2		* Command

MTB3	BTST	#7,IN1			* Wait for Acknowledge
	BEQ	MTB3			

MTB4	MOVE	(A0)+,LNKWR

MTB5	BTST	#7,IN1			* Master's LNKFLAG=0 active, Reset by
	BEQ	MTB5			*		Slave's ACK

	SUBQ.W	#1,D1
	BNE	MTB4			* Do it until we are done

	CLR.W	LNKWR			* Do Dummy LNKWR

MTB6	BTST	#7,IN1			* Wait for last ACK
	BEQ	MTB6			

	CLR.W	TXBUFFH			* Turn off TX Buffer
MTB7	RTS

*===============================================================================
* Slave receives Tracer List from Master 
LCOM5:
	LEA	TRIN,A1			* Tracer Input Buffer

LC5A	BTST	#6,IN1			* Wait for LNKFLAG
	BNE	LC5A

	MOVE.W	LNKRD,D1		* The first data word is # words
	MOVE.W	D1,(A1)+		* We will need to remember how many

	CLR.W	ACKH			* Acknowledge
	CLR.W	ACKL

LC5B	BTST	#6,IN1			* Wait for LNKFLAG
	BNE	LC5B

	MOVE.W	LNKRD,(A1)+		* Now we're cooking
	CLR.W	ACKH			* Acknowledge
	CLR.W	ACKL

	SUBQ.W	#1,D1
	BNE	LC5B

	MOVEM.L	(A7)+,D0/D1/A0/A1	* Restore Registers from the Stack
	RTE
*===============================================================================
	PAGE
* Master receives Tracer Buffer from Slave 
STBIN: 
	CLR.W	TXBUFFL			* Turn on TX Buffer
	MOVE.W	#$8005,LNKWR+2		* Command

STB1	BTST	#7,IN1			* Wait for Acknowledge
	BEQ	STB1

	CLR.W	TXBUFFH			* Turn off TX Buffer

	CLR.W	LNKWR			* Do a dummy write to set the Link Flag
*					  (Master tells Slave "Ready")

	LEA	TRIN,A1			* Point to Tracer Input Buffer	

STB2 	BTST	#7,IN1			* Wait for Slave's ACK (Data is ready)
	BEQ	STB2
	
	MOVE.W	LNKRD,D0		* First word contains # words
	MOVE.W	D0,(A1)+

	BEQ	STB5			* check for '0' just in case

	SUBQ.W	#1,D0			* We have done one already
	BEQ	STB5

STB3	CLR.W	LNKWR			* Do a dummy write to set the Link Flag

STB4	BTST	#7,IN1			* Wait for Slave's ACK
	BEQ	STB4				
	
	MOVE.W	LNKRD,(A1)+		* Next word

	SUBQ.W	#1,D0
	BNE	STB3			* Go again

STB5	CLR.W	LNKWR			* Set the last Link Flag

*STB6	BTST	#7,IN1			* Wait for last ACK
*	BEQ	STB6
	
	RTS				* We are done.
*===============================================================================
* Slave sends Tracer List to Master
LCOM6:
	LEA	TROUT,A1	* Tracer Output List
	MOVE.W	(A1),D0		* D0 = # Words
	BNE	LC6A		* Should not be '0'
	ADDQ.W	#1,D0		* But if it is, ok

LC6A	BTST	#6,IN1
	BNE	LC6A		* Wait for next LNKFLAG

* Master is ready to receive
	CLR.W	TXBUFFL		* Turn on TX Buffer

LC6B	MOVE.W	(A1)+,LNKWR	* Send data
	
	CLR.W	ACKH		* Tell Master there is data waiting
	CLR.W	ACKL

LC6C	BTST	#6,IN1		
	BNE	LC6C		* Wait for next LNKFLAG

	SUBQ.W	#1,D0
	BNE	LC6B		* Go back for another word

LC6D	BTST	#6,IN1
	BNE	LC6D		* Wait for last LNKFLAG

	CLR.W	ACKH		* Acknowledge
	CLR.W	ACKL

	CLR.W	TXBUFFH		* Turn off TX Buffer	
	MOVEM.L	(A7)+,D0/D1/A0/A1	* Restore Registers from the Stack
	RTE
*===============================================================================
	PAGE
* Generate the Tracer Output Buffer
* First word will contain the size of the list
* A list of no active tracers is size '1'
TRB:
	LEA	TROUT+2,A1    		* reserve 1st word for count
	LEA	G_DATA,A0		* Beginning of Gun Block
	MOVE.W	#GMAX,D0		* maximum number of tracers	
	MOVE.W	#1,D1			* keep a count of the list length

TRB1	TST.W	GFLAG(A0)		* Tracer active?
	BEQ	TRB2			* no

	MOVE.W	GXT(A0),(A1)+
	MOVE.W	GYT(A0),(A1)+
	MOVE.W	GZT(A0),(A1)+

	ADDQ.W	#3,D1			* increment list size
TRB2	ADDA.W	#GBLK,A0		* next block

	SUBQ.W	#1,D0			* done yet?
	BNE	TRB1			* no

	MOVE.W	D1,TROUT	* First word contains the size of the list

	RTS
*===============================================================================
* Initialise GAME LINK
GLINIT:

* ACK is normally Low
	CLR	ACKL

* ERR is normally Low
	CLR	ERRL

* Disable TXBUFF
	CLR	TXBUFFH

* Select Master/Slave
	BTST	#OSW7,INPUTS+1
	BEQ	GLIN1
	CLR	LNKMODEL		* Master
* Master TXBUFF is normally On 
	CLR	TXBUFFL
	RTS

GLIN1	CLR	LNKMODEH		* Slave
* Slave TXBUFF is normally off
	CLR	TXBUFFH

	RTS

	END
*===============================================================================
